#include <p18cxxx.h>
#include "system\typedefs.h"

#include "system\usb\usb.h"

#include "io_cfg.h"             // I/O pin mapping
#include "user\user.h"
#include "user\KeyDef.h"

#define	MouseL	Button&1
#define	MouseR	Button&2
#define	MouseC	Button&4

#define Ep1Busy	HID_BD_IN.Stat.UOWN

extern byte active_protocol;
extern byte idle_rate[2];
extern void USBTasks(void);

#pragma udata

byte i,j,k;
byte InKeyL,  InKeyR,  InKeyT;
byte CurKeyL, CurKeyR, CurKeyT;
byte KeyOn;					// Ō
byte KeyBuf[8];				// u[N҂obt@
word ModeCodeBuf[16];			// ]҂f[^obt@
word *Top, *Last;				// ModeCodeBufp|C^

char Kana,KanaMode,KanaToggle;
// Kana:PC̓̓[h	KanaMode:Perky̓̓[h
// Kana̕ύX̓L[{[hɂ͒m炳Ȃ̂ŁAIMEAvɕύXȂ悤ɐݒ肷邱ƁB
// Kana!=KanaModeɂȂĂ܂͉ÊTL[uLTSCHvŌKana]B
char Caps,NumLock,ScrollLock;
char Shift,Ctrl,Alt,Win,ShiftSet,CtrlSet,AltSet;
char Num,Num2,Kakko,Kigou1,Kigou2,Kigou3,Fn1,Fn2;
byte LED,LEDWait;

int  BreakTimer,WaitTimer,KeyMouseTimer,KeyWheelTimer;
char NumTimer;
byte IdleTimer0,IdleTimer1;

byte Button,MouseTouch,KeyTouch;
char MouseX,MouseY,Wheel;

byte CODE,MODE,BUTTON;						
byte FirstCode,LastCode;

int BREAK_TIME, KEYMOUSE_TIME, KEYWHEEL_TIME0, KEYWHEEL_TIME1;


#pragma code

void UserInit(void)
{
	ADCON1=0x0F;		// RARBRE All Digital
	CCP1CON=CCP2CON=0;// CCP͎gȂ
	
	TRISB=TRISD=0xFF; // RD:Left	RB:Right		RA:Thumb
					// RA0:L0	RA1:L5	RA2:R0	RA3:R5
	TRISA=0xDF;		// RA4:MouseTouch		RA5:MouseTouchLED
	TRISC=TRISE=0;
	
	INTCON2=0x7F;		// RB̓vAbv
	PORTEbits.RDPU=1;	// RD̓vAbv
	
	PORTAbits.RA5=0;	// MouseTouchLED off
	
	Kana=KanaMode=KanaToggle=0;
	Caps=NumLock=ScrollLock=0;
	Shift=Ctrl=Alt=Win=ShiftSet=CtrlSet=AltSet=0;
	Num=Num2=Kakko=Kigou1=Kigou2=Kigou3=Fn1=Fn2=0;
	LED=LEDWait=0;
	
	InKeyL=InKeyR=InKeyT=0;
	CurKeyL=CurKeyR=CurKeyT=0;
	Top=Last=&ModeCodeBuf[0];	
	MODE=CODE=0;
	FirstCode=LastCode=0;
	KeyOn=0;	MouseTouch=KeyTouch=0;			

	Button=0;	BUTTON=0;
	MouseX=MouseY=Wheel=0;
	
	BreakTimer=-1;	NumTimer=-1;	WaitTimer=0;	
	KeyMouseTimer=KeyWheelTimer=-1;
	IdleTimer0=IdleTimer1=idle_rate[0]=idle_rate[1]=0;

	BREAK_TIME=90;							// Ōe(ms)						
	KEYWHEEL_TIME0=400;	KEYWHEEL_TIME1=50;	// L[ɂzC[̃s[gJn
}


void ProcessIO(void)
{   
    if((usb_device_state < CONFIGURED_STATE)||(UCONbits.SUSPND==1)) return;
						// ʐM\		// ꎞ~
	SetKey(1);
	SetMouse(1);
	CheckKeyOn();
	CheckBreak();
	if(KeyOn==0)
	{
		CheckKeyOff();
		CheckAllClear();
	}
	MouseIn();
}

byte KeyIn(void)
{
	InKeyL=(byte)~PORTD;		// On=0 Off=1  On=1 Off=0
	InKeyR=(byte)~PORTB;
	InKeyT=(byte)~PORTA;

	InKeyT&=0x0F;
	if(InKeyL||InKeyR||InKeyT)	return(1);
	else					return(0);
}

void SaveKey(byte n)
{
	if(8<=KeyOn)		return;
	
	KeyBuf[KeyOn]=n;
	KeyOn++;
	if(KeyOn==1)
	{
		BreakTimer=BREAK_TIME;

		NumTimer=50;
		if(!ShiftSet&&Shift&& !(InKeyL&0x10)&& !(InKeyT&0x02))
			Shift=0;
	}
}

void CheckKeyOn(void)
{
	byte NewKeyL, NewKeyR, NewKeyT;

	KeyIn();
	
	NewKeyL=(InKeyL^CurKeyL)& InKeyL;
	if(NewKeyL)
	{
		for(i=0; i<8; i++)
		{
			if((NewKeyL>>i)& 1)	SaveKey(i);
		}
		CurKeyL|=NewKeyL;
	}
	NewKeyR=(InKeyR^CurKeyR)& InKeyR;
	if(NewKeyR)
	{
		for(i=0; i<8; i++)
		{
			if((NewKeyR>>i)& 1)	SaveKey(8+i);
		}
		CurKeyR|=NewKeyR;
	}
	NewKeyT=(InKeyT^CurKeyT)& InKeyT;
	if(NewKeyT)
	{
		for(i=0; i<4; i++)
		{
			if((NewKeyT>>i)& 1)	SaveKey(16+i);
		}
		CurKeyT|=NewKeyT;
	}
}

void CheckKeyOff(void)
{
	byte K,Kl,Kr,Kt;
	
	KeyIn();
	Kl=(InKeyL^CurKeyL)&CurKeyL;
	Kr=(InKeyR^CurKeyR)&CurKeyR;
	Kt=(InKeyT^CurKeyT)&CurKeyT;

	if(Kl|Kr|Kt)
	{
		Wait(30);
		KeyIn();
		K=(InKeyL^CurKeyL)&CurKeyL&Kl;	CurKeyL&=~K;
		K=(InKeyR^CurKeyR)&CurKeyR&Kr;	CurKeyR&=~K;
		K=(InKeyT^CurKeyT)&CurKeyT&Kt;	CurKeyT&=~K;
		PushCode0();
		KeyWheelTimer=-1;
	}

	if(Button)
	{
		if(MouseL&&((CurKeyT & 0x02)==0))	Button&=6;	// L5
		if(MouseR&&((CurKeyL & 0x40)==0))	Button&=5;	// L8
		if(MouseC&&((CurKeyL & 0x10)==0))	Button&=3;	// L6
	}

	if(Num)
	{
		if((CurKeyT & 0x02)==0)	Num=0;
	}
}

void CheckAllClear(void)
{
	byte SetMode;

	if(KeyIn())		return;
	if(CurKeyL|CurKeyR|CurKeyT)	return;		
	
	Num=Kakko=Kigou1=Kigou2=Kigou3=Fn1=Fn2=0;
	
	if(ScrollLock)	ScrollLockToggle();
	
	if(Button)	Button=0;
	KeyTouch=0;

	SetMode=0;
	if(!ShiftSet && Shift)	{ Shift=0;	SetMode++; }
	if(!CtrlSet && Ctrl)	{ Ctrl=0;	SetMode++; }
	if(!AltSet && Alt)	{ Alt=0;		SetMode++; }

	if(SetMode||CODE)	PushCode0();
}

void CheckBreak(void)
{
	if(BreakTimer!=0)	return;
	BreakTimer=-1;
	FirstCode=1;

	for(i=0; i<KeyOn-1; i++)	// L[ԍɃ\[g
	{
		for(j=i+1; j<KeyOn; j++)
			if(KeyBuf[j]<KeyBuf[i])	{ k=KeyBuf[i];	KeyBuf[i]=KeyBuf[j];	KeyBuf[j]=k; }
	}

	switch(KeyOn)
	{
	case 1:	Check1Key();						break;
	case 2:	Check2Key();						break;
	case 3:	Check3Key();						break;
	case 4: if(Shift||!KanaMode)	AscN(4);
			else				KanaN(4);	break;
	case 5:	if((KeyBuf[0]==R1)&&(KeyBuf[4]==R5))
			{						// R5R1R2R3R4Ō
				if(Kana)	Kana=0;		// PCJi[htO̔]
				else	Kana=1;
			}
			else if(Shift||!KanaMode)	AscN(5);
			else					KanaN(5);	break;
	case 6:	AscN(6);								break;
	case 7:	AscN(7);								break;
	case 8:	AscN(8);								break;
	}
	KeyOn=0;
}

void Check1Key(void)
{
	byte Kn0,i,j,Code0;
	Kn0=KeyBuf[0];	i=Kn0/8;	j=Kn0%8;
	
	if(MouseTouch||KeyTouch)
	{
		if(Num)
		{
			if(CurKeyL&0x22)
			{
				if(Kn0==L2)	Wheel++;
				else 		Wheel--;
				KeyWheelTimer=KEYWHEEL_TIME0;
			}
			else if(CurKeyL&0x05)
			{
				if(!ScrollLock)	ScrollLockToggle();
				PushCode22((Kn0==L3)?uLeft:uRight);
			}
			else goto SKIP;
		}
		else if((CurKeyL&0x27)&&KeyTouch)
		{
			switch(Kn0)
			{
			case L1:		MouseX++;	break;
			case L3:		MouseX--;	break;
			case L2:		MouseY--;	break;
			case L7:		MouseY++;	
			}
			KeyMouseTimer=KEYMOUSE_TIME=14;
		}
		else if((CurKeyL&0x50)||(Kn0==L5))
		{
			if(Kn0==L5)		Button|=1;	// L
			else if(Kn0==L8)	Button|=2;	// R
			else if(Shift||Ctrl||Alt)	goto SKIP;	// Ctrl+W Alt+W
			else			Button|=4;	// C
		}
		else 	goto SKIP;
		
		ShiftSet=CtrlSet=AltSet=0;	
		return;
	}
SKIP:
	if(Num)										// PageDown PageUp 
	{											// ESC TAB 0123456789
		Code0=KeyCode2[i][j];
		if(Kn0==L4)									// TAB
		{
			PushCode22(uTab);
			ShiftSet=CtrlSet=AltSet=0;
			FirstCode=0;		// VtgL[ȊÕL[ꂽ
		}
		else if(Kn0==L9)								// ESC->Enter
		{
			PushCode22(uRet);
		}
		else if(Kn0<L9)								// PageDown PageUp 
		{
			if(ScrollLock)	ScrollLockToggle();
			PushCode22(Code0);
		}
		else
		{
			if(!NumLock)	NumLockToggle();				// NumLock On
			PushCode22(Code0);						// 0123456789
		}
	}
	else if((R1<=Kn0)&&(Kn0!=L0)&&(Kn0!=L5))
	{
		if((Kakko)&&(CurKeyL&0x80))					// RET+
		{
			if(Kn0<=R9)				
			{
				Code0=KeyCode2[6][j];
				if((Kn0==R3)||(Kn0==R8))	PushCode00(Code0);	// [ ]
				else					PushCode10(Code0);	// ( ) { } < >
			}
			else											//  
			{
				if(Kn0==R0)		Code0=48;
				else			Code0=49;
				PushKanaS(Code0);
				Shift=0;
			}
		}
		else if((Kigou1)&&(CurKeyL&0x10))					// W+ : Kigou1 (L6)
		{
			if(Kn0==R0)		PushCode10(0x21);				// $
			else if(Kn0==R5)	PushCode00(0x31);				// ϰ
			else
			{
				Code0=KeyCode2[4][j];
				if((Kn0==R3)||(Kn0==R9))	PushCode00(Code0); 	// ^@@
				else		 			PushCode10(Code0); 	// ! | # = & ~
			}
		}
		else if((Kigou2)&&(CurKeyL&0x40))					// BS+  : Kigou2 (L8)
		{
			if(Kn0<=R9)
			{
				Code0=KeyCode2[5][j];
				if((Kn0==R1)||(Kn0==R4)||(Kn0==R6))			// ' ? "
								PushCode10(Code0);
				else if(Kn0==R9)	PushKanaS(Code0);			// 
				else			PushCode00(Code0);		// ; :
			}
			else if(Kn0==R0)	PushCode10(0x22);				// %
			else if(Kn0==R5)	PushCode00(0x2D);				// _
		}
		else if((Fn1)&&(CurKeyL&0x10)&&(CurKeyT&0x02))	// Fn1 (L5L6)
		{
			if(Kn0==R0)		Code0=0x3A;					// F1
			else if(Kn0==R5)	Code0=0x3F;					// F6
			else
			{
				Code0=KeyCode3[1][Kn0-8];
			}
			PushCode22(Code0);
		}
		else if((Fn2)&&(CurKeyL&0x40)&&(CurKeyT&0x02))
		{
			if(Kn0==R0)		Code0=0x46;					// PrintScreen
			else if(Kn0==R5)	Code0=0x48;					// Break
			else										// HOME DEL INS END F11 F12 ϊ ϊ
			{
				Code0=KeyCode3[0][Kn0-8];
			}
			PushCode22(Code0);
		}
		else if(((Kn0==R2)||(Kn0==R3)||(Kn0==R6)||(Kn0==R7)||(Kn0==R8))
			&&(CurKeyT&0x08)&&(CurKeyL==0)&&((CurKeyT&0x03)==0))
		{
			KeyBuf[1]=R5;		Check2Key();					// -- // .. ++ **
		}
		else goto ASCKANA;
	}
	else 
	{
	ASCKANA:
		if(Ctrl||Shift||Alt||!KanaMode)	AscN(1);				// Ctrl+ Shift+ Alt+=Ascii
		else KanaN(1);									//  Ӱ
	}
}

void Check2Key(void)
{
	byte Kn0,Kn1,i,j,k,Code0;
	Kn0=KeyBuf[0];	Kn1=KeyBuf[1];	i=Kn0/8;	j=Kn0%8;	k=Kn1%8;

	if((Kn0==R2)&&(Kn1==R3))		// SpЂ炪ȃ[h
	{
		if(!KanaMode)
		{
			KanaMode=1;	PushKana(uCaps);
		}							
	}
	else if((Kn0==R3)&&(Kn1==R0))	// p[h+CAPS
	{
		KanaModeOff();
		if(!Caps)	CapsToggle();
	}
	else if((Kn0==R8)&&(Kn1==R0))	// p[h+caps
	{
		KanaModeOff();
		if(Caps)	CapsToggle();
	}
	else if((Kn0==L4)&&(Kn1==L0)&&MouseTouch)	// Alt+F+X 
	{
		KanaModeOff();
		AltSet=Alt=1;
		PushAsc2(uF,uX);
	}
	else if((Kn0==L9)&&(Kn1==L0))	// p^Sp
	{
		PushCode22(0x35);		PushCode0();
	}
	else if((Kn0==L6)&&(Kn1==L7))	// 
	{
		if(!KeyTouch&&((CurKeyT&0x0C)||CurKeyR)
			&&(LastCode!=36)&&(LastCode!=31)&&(LastCode!=uSp))	// ' " space
			{ AscN(2);	return; }							// es
		if(Caps)	CapsToggle();
		if(ShiftSet)
		{
			ShiftSet=Shift=0;
		}
		else
		{
			ShiftSet=Shift=1;
 			KanaMode=0;
		}
		PushCode0();
	}
	else if((((CurKeyT&0x0C)|CurKeyR)==0)||KeyTouch)	// ẼL[͉ĂȂor KeyTouch
	{
		if((Kn0==L7)&&(Kn1==L8))	// ۰
		{
			if(Ctrl)	CtrlSet=Ctrl=0;
			else	CtrlSet=Ctrl=1;
			PushCode0();
		}
		else if((Kn0==L6)&&(Kn1==L8))	// ALT
		{
			if(Alt)
			{
				AltSet=Alt=0;
			}
			else
			{
				AltSet=Alt=1;
				KanaMode=0;
			}
			PushCode0();
		}
		else if((MouseTouch||KeyTouch)&&(Kn1==L5)&&(((L1<=Kn0)&&(Kn0<=L3))||(Kn0==L7))
			&&!Shift&&!Ctrl&&!Alt)
		{
			if((Kn0==L2)||(Kn0==L7))			// Wheel
			{
				if(Kn0==L2)	Wheel++;
				else 		Wheel--;
				KeyWheelTimer=KEYWHEEL_TIME0;
			}
			else 							// Tilt
			{
				if(!ScrollLock)	ScrollLockToggle();
				PushCode22((Kn0==L3)?uLeft:uRight);
			}
			Num=1;
			return;
		}
		else if((Kn1==L5)&&(Kn0<=L9))			// ߰ +
		{
			if(ScrollLock)	ScrollLockToggle();
			Num=1;				// ESC PageDown PageUp  TAB
			PushCode22(KeyCode2[i][j]);
		}
		else if(Ctrl||Shift||!KanaMode)	AscN(2);
		else							KanaN(2);
	}
	else if((Kn1==L5)&&(L6<=Kn0))				// ߰ +
	{
		Code0=KeyCodeAsc[i][j];
		if(Kn0<=L9)			// ESC PageDown PageUp  TAB
		{
			if(ScrollLock)	ScrollLockToggle();
			if((CurKeyL&0x0F)||CurKeyR||(CurKeyT&0x0C))
			{
				PushAsc2(Code0,uSp);
				return;
			}
		}
		else						// 12346789
		{
			if((Kn0==L0)||(!KanaMode&&(!Num2||(CurKeyL&0x0F)||((Kn0!=R7)&&(CurKeyR&0x20)))))
			{										// uoie n + ߰
				if(Kn0==L0)
				{
					if(KanaMode)	PushKana(uAo);	// 
					else		PushAsc(uA);		// a
				}
				else
				{
					PushAsc(Code0);
				}
				PushAsc(uSp);						// ߰
				return;
			}
			Shift=0;
			if(!NumLock)	NumLockToggle();		// NumLock On
			Num=1;
			PushCode02(KeyCode2[i][j]);
		}
	}
	else if((Kn0==L5)&&((Kn1==R0)||(Kn1==R5)))	// 0 5
	{
		if(!KanaMode&&(!Num2||(CurKeyT&1)||(CurKeyL&0x0F)))	// uoie a + ߰
		{
			Code0=KeyCodeAsc[Kn1/8][k];
			PushAsc2(Code0,uSp);
			return;
		}
		Shift=0;
		Num=1;
		if(!NumLock)	NumLockToggle();		// NumLock On
		if(Kn1==R0)	PushCode02(u0);		// 0
		else		PushCode02(u5);		// 5
	}
	else if((Kn1==R5)&&(R1<=Kn0)&&(Kn0<=R9))	// , - / Z . + * X  : Kigou3 (R5)
	{
		Code0=KeyCode2[i+2][j];
		if(Kn0==R2)		PushCode22(Code0);	// -
		else if((Kn0==R4)||(Kn0==R9))
		{
			if(KanaMode&&!Ctrl)				//  ާ
			{
				PushKana(uAu);
				if(Kn0==R9)	PushKana(uDak);
				PushKanaS(uAa);
			}
			else
			{
				AscN(2);		return;			// ZX
			}
		}
		else if((Kn0==R1)||(Kn0==R6))				PushCode00(Code0);	// , .
		else if((Kn0==R7)||(Kn0==R8)||(Kn0==R3))	PushCode22(Code0);	// + * /
		if(Num && !ShiftSet && Shift)	Shift=0;
		Kigou3=1;
	}
	else if((Kn0==L6)&&(R1<=Kn1))		// ! | ^ # = & ~ @ $ ϰ	: Kigou1 (L6)
	{
		if(Kn1==R0)		Code0=33;		// $
		else if(Kn1==R5)	Code0=137;		// ϰ
		else			Code0=KeyCode2[4][k];
		
		if(Kn1==L0)	PushAsc2(uA,uN);
		else if((Kn1==R3)||(Kn1==R5)||(Kn1==R9))
			PushCode00(Code0);		// ^ @ ϰ
		else
			PushCode10(Code0);		// ! | # = & ~ $
		Kigou1=1;
	}
	else if((Kn0==L8)&&(R1<=Kn1))		// ' ; WIN ? " : APP  % _ Q 	: Kigou2 (L8)
	{
		if(Kn1<=R9)		
		{
			Code0=KeyCode2[5][k];
			if(Kn1==R3)							// WIN
			{
				KanaModeOff();
				Win=1;	PushCode0();
				Win=0;	PushCode0();
			}
			else if(Kn1==R8)
			{
				KanaModeOff();
				PushAsc(uApp);					// APP
			}
			else if((Kn1==R1)||(Kn1==R4)||(Kn1==R6))
			{
				PushCode10(Code0);				// ' ? "
				LastCode=Code0;
			}
			else if(Kn1==R9)	PushKanaS(Code0);		// 
			else			PushCode00(Code0);	// ; :
		}
		else if(Kn1==R0)	PushCode10(34);			// %
		else if(Kn1==R5)	PushCode10(135);			// _
		Kigou2=1;
	}
	else if((Kn0==L9)&&(R1<=Kn1)&&(Kn1!=L0)&&(Kn1!=L5))		// 
	{
		if(Kn1<=R9)				
		{
			Code0=KeyCode2[6][k];
			if((Kn1==R3)||(Kn1==R8))	PushCode00(Code0);	// [ ]
			else					PushCode10(Code0);	// ( ) { } < >
		}
		else											//  
		{
			if(Kn1==R0)		Code0=48;
			else			Code0=49;
			PushKanaS(Code0);
			Shift=0;
		}
		Kakko=1;
	}
	else
	{
		if(Ctrl||Shift||!KanaMode)		AscN(2);
		else						KanaN(2);
	}
}

void Check3Key(void)
{
	byte Code0;
	byte Kn0,Kn1,Kn2;
	Kn0=KeyBuf[0];	Kn1=KeyBuf[1];	Kn2=KeyBuf[2];

	if((Kn0==R6)&&(Kn1==R7)&&(Kn2==R5))	KeyTouch=1;		// KeyTouch
	else if((Kn0==L6)&&((Kn1==L5)||(Kn2==L5))&&(R1<=Kn1))	// Fn
	{
		if(Kn1==L5)
		{
			if(Kn2==R0)	Code0=uF1;		// F1
			else		Code0=uF6;		// F6
		}
		else
		{
			Code0=KeyCode3[1][Kn1-8];
		}
		PushCode22(Code0);
		Fn1=1;
	}
	else if((Kn0==L8)&&((Kn1==L5)||(Kn2==L5))&&(R1<=Kn1))	
	{			   								
		if(Kn1==L5)
		{
			if(Kn2==R0)	Code0=0x46;				// PrintScreen
			else		Code0=0x48;				// Break
			PushCode22(Code0);
		}
		else									// HOME DEL INS END F11 F12 ϊ ϊ
		{
			Code0=KeyCode3[0][Kn1-8];
			PushCode22(Code0);
		}
		Fn2=1;
	}
	else if(((Kn0==R1)||(Kn0==R2)||(Kn0==R6))&&(Kn1==L5)&&(Kn2==R5))	// ,.- + Sp
	{
		if(Kn0==R1)		Code0=54;	// ,
		else if(Kn0==R2)	Code0=86;	// -
		else			Code0=55;	// .
		PushCode00(Code0);
		PushAsc(uSp);
	}
	else
	{
		if(Shift||!KanaMode)	AscN(3);
		else				KanaN(3);
	}
}


void PushAsc(byte Code)
{
	PushCode(Code,2,0);
	LastCode=Code;
}

void PushKana(byte Code)
{
	PushCode(Code,0,1);
}

void PushKanaS(byte Code)
{
	PushCode(Code,1,1);
}

void PushCode22(byte Code)
{
	PushCode(Code,2,2);
}

void PushCode02(byte Code)
{
	PushCode(Code,0,2);
}

void PushCode00(byte Code)
{
	PushCode(Code,0,0);
}

void PushCode10(byte Code)
{
	PushCode(Code,1,0);
}

void PushAsc2(byte Code1, byte Code2)
{
	PushCode(Code1,2,0);	PushCode(Code2,2,0);
	LastCode=Code2;
}

void PushAsc3(byte Code1, byte Code2, byte Code3)
{
	PushCode(Code1,2,0);	PushCode(Code2,2,0);	PushCode(Code3,2,0);
	LastCode=Code3;
}

void PushAscL(byte Code)
{
	PushCode(Code,!Caps,0);
}

void PushCode0(void)
{
	PushCode(0,2,2);
}

void KanaN(byte n)
{
	byte i, j, Code0=0;
	byte bn, sn, b[5], s[5];
	byte Dak=0,Han=0,Tu=0;
	byte CodeP=0,CodePs=0;	
	byte b0,s8;								

	bn=sn=0;
	b[0]=b[1]=s[0]=s[1]=20;	// ǂ̃L[ɂ}b`OȂ

	for(i=0; i<n; i++)
	{
		if((KeyBuf[i]<=L9)||(KeyBuf[i]==L0)||(KeyBuf[i]==L5))	b[bn++]=KeyBuf[i];
		else											s[sn++]=KeyBuf[i];
	}
	
	if((4<=bn)||(4<=sn))	{ AscN(n);	return; }
	
	if(n==1)
	{
		if(((CurKeyL&0x0F)|CurKeyR|CurKeyT)&&(b[0]==L8))		Tu=1;
		else
		{
			if(b[0]==L6)	CodePs=uWo;
			else 		Code0=KeyCodeKana[0][KeyBuf[0]];
			FirstCode=0;
		}
		goto DakPushK;
	}
	if((bn==1)&&(b[0]==L4)&&sn&&(s[1]!=R5))
	{
		CodeP=uAa;					// 
		n--;	bn=0;	KeyBuf[0]=s[0];
	}
	if((s[1]==R0)&&((s[0]==R2)||(s[0]==R7)))		//  
	{
		if(s[0]==R2)	Han=1;
		else		Dak=1;
		if(bn==0)	{ Code0=uHa;	goto PushK; }
		sn=1;	n--;
		s[0]=R4;	s[1]=20;
	}

	b0=KeyCodeKana[0][b[0]%4];

	s8=s[0]-8;

	if((n==2)||(sn==3))
	{
		if(s[1]==R0)
		{
			switch(s[0])
			{
			case R1:	CodePs=0x36;	break;			// A
			case R6:	CodePs=0x37;	break;			// B
			case R4:	Code0=uHu;					// ӂ
			case R9:	CodePs=uAa;					// 
			}
		}
		else if(s[1]<=R3)
		{
			Code0=uAi;	CodeP=uAu; 				// 
			if(s[1]==R3)	CodeP=uAi;				// 
		}
		else if(s[1]==R7)		Code0=uWa;			// 
		else if(b[1]==L6)
		{
			Code0=b0;
		CHO:	CodeP=uCho;							// 
		}
		else if(b[1]==L0)
		{
			Code0=uAo;									// 
			switch(b[0])
			{
			case L1:	Code0=uYo;					break;	// 
			case L2:	CodeP=uAu;					break;	// 
			case L3:	Code0=uAe;	CodeP=uAi;		break;	// 
			case L4:	CodeP=uAo;					break;	// 
			case L6:	goto CHO;							// 
			case L7:	goto NN;								// 
			case L8:	goto TU;								// 
			}
		}
		else if(b[1]==L9)
		{
			Code0=uYa;									// 
			if(b[0]==L1)			goto NN;					// 
			else if(b[0]==L8)		CodeP=uAa;				// Ա
			else 				goto CHO;				// ԰
		}
		else if(b[1]==L8)
		{
			Code0=b0;
			if(b[0]==L1)		goto CHO;					// 
			else			goto NN;						// 
		}
		else if(b[1]<=L4)
		{
			Code0=b0;
			if((b[0]==L1)&&(b[1]!=L3))
			{
				if(b[1]==L2)	Code0=uYu;					// 
				else 		Code0=uYa;					// 
			}
			else
			{
				if((b[0]==L2)&&(b[1]==L3))	Code0=uAe;		// 
				else if(b[0]==L3)			Code0=uAa;		// 
				Tu=1;									//  
			}
		}
		else
		{
			if((b[0]==L7)||(b[1]==L7))
			{
				if(s[0]<=R5)		Code0=KeyCodeKana[0][s[0]]; // ޻޶
				else if(b[0]<=L4)	Code0=b0;	// 
				else			Code0=uAo;	// 
			NN:
				CodeP=uNn;					// 
			}
			else
			{
				if(b[0]==L0)	j=3;
				else 		j=b[0];
				Code0=KeyCodeKana2[s8][j];
			}
			goto DakPushK;
		}
		goto PushK;
	}
BOIN:
	if(bn==3)	//        
	{
		if((b[0]==L7)&&(b[1]==L8))
		{
		TU:	CodeP=0;	Tu=1;					   	// 
			goto PushK;
		}
		if((b[0]==L8)&&(b[1]==L9))	goto CHO; 		// 
		
		CodePs=KeyCodeKana2[13][b[1]%4];			// 
		if((b[2]==L0)&&(b[1]==L3))	CodeP=uAi;		// 
		else if((b[2]==L0)||((b[2]==L5)&&(b[1]==L7)))
		{
			CodePs=uYo;							// 
			if(b[1]==L8)		Tu=1;				// 
			else if(b[1]==L2)		CodeP=uAu;		// 
			else 				CodeP=uNn;		// 
		}
		else if((b[1]==L4)||(b[2]==L5))
		{
			if((sn==0)&&(b[1]==L3))	{ Code0=uAi;	goto PushK; }	// 
			if(b[1]==L8)	;						// 
			else 			Tu=1;				// 
		}
		else if(b[2]==L8)
		{
			CodeP=uNn;							//  
			if((b[0]==L1)&&(b[1]==L7))	CodePs=uAe;	// 
		}
		else 				CodeP=uAu;			// 

		if(b[0]==L6)	CodeP=uCho;					// 
		Code0=KeyCodeKana2[s8][0];
		if(sn==0)
		{
			Code0=CodePs;
			CodePs=0;
		}
		goto DakPushK;
	}
	else //if((bn==2)||(bn==1))	//         
	{
		if(b[1]==L9)
		{
			CodePs=uYa;							// 
			if(b[0]==L1)		CodeP=uNn;	  		// 
			else if(b[0]==L8)	CodeP=uAa;			// Ա
			else 			CodeP=uCho;			// ԰
			b[0]=L1;
		}
		else if(((b[0]==L3)&&(b[1]==L0))||((b[0]==L6)&&(b[1]==L7)))
		{
			CodeP=uAi;		b[1]=20;				//  
		}
		else if(((b[0]==L1)&&(b[1]==L8))||(b[1]==L6)||(b[0]==L6))
		{
			CodeP=uCho;							// 
		}
		else if((b[0]==L7)&&(b[1]==L8))
		{
			CodeP=uAe;		b[1]=20;	b[0]=L3;		// 
		}
		else if((b[1]==L7)||(b[1]==L8)||(b[0]==L7))
		{
			CodeP=uNn;							// 
		}
		else if((b[1]==L5)||(b[0]==L8))
		{
			Tu=1;								// 
		}
		else if((b[0]==L2)&&((b[1]==L3)||(b[1]==L0)))
		{
			CodeP=uAu;							// 
		}
		else if((b[0]==L4)&&(b[1]==L0))
		{
			CodeP=uAo;		b[0]=20;				// 
		}
		else if(bn==2)
		{
			CodePs=KeyCodeKana2[13][b[1]%4];		// 
		}

		if(sn==1)
		{
			i=b[0]%4;
			if(CodePs)			;				// 
			else if((b[0]==L0)||(b[1]==L0))	i=3;
			if(b[0]==L4)	Code0=KeyCodeKana[0][s[0]];
			else 		Code0=KeyCodeKana2[s8][i];
		DakPushK:
			if((R6<=s[0])&&(s[0]<=R8))	Dak=1;
		}
		else // sn==2
		{
			if((s[0]==R6)&&(s[1]==R7))	Code0=uWa;		//  ܰ ܯ
			else
			{
				if((b[0]==L0)||(b[1]==L0))	CodePs=uAo;	// 
				else 	CodePs=KeyCodeKana2[9][b[0]];
				if((bn==1)&&(b[0]==L7))	CodePs=uAa;	// 

				if(s[1]==R0)
				{
					if(s[0]==R4)	Code0=uHu;			// 
					else if(s[0]<=R6)					// è
					{
						Code0=uTe;	
						if((b[0]==L0)||(b[1]==L0))
						{
							Code0=uTo;	CodePs=uAu;	// ĩ ީ
						}
					}
					else if(b[0]==L2)	CodePs=uAu;		// 
				}
				else// if(s[1]==R5)
				{
					if(s[0]==R1)	// §¨ª«
					{
						Code0=uTu;
					}
					else //if((s[0]==R4)||(s[0]==R9))	// ޳ިޭުޫ
					{
						Code0=uAu;		Dak=1;
						if(s[0]==R4)
						{
							if(b[0]==L2)	CodePs=0;		// 
							else 		Dak=0;
						}
						else if(b[1]==L5)	// for( if( else
						{
							KanaModeOff();
							AscN(4);	return;
						}
					}
				}
				goto DakPushK;
			}
		}
	}
PushK:
	if(Code0)	PushKana(Code0);
	if(Dak)		PushKana(uDak);
	if(Han)		PushKana(uHan);
	if(CodePs)	PushKanaS(CodePs);
	if(Tu)
	{
		if(Code0==uTu)	PushCode0();		// ¯
		PushKanaS(uTu);
	}
	if(Code0==CodeP)	PushCode0();			// 
	if(CodeP)	PushKana(CodeP);
}

void AscN(byte n)		
{
	byte Code0=0,Code1=0,Code2=0,Code3=0,aswap=0,Sp=0,Ka=0,Ret=0;
	byte bn=0,sn=0,b[8],s[8],i,j;
	byte LastS=0;
	byte Th=0;

	s[0]=s[1]=s[2]=s[3]=20;	// ǂ̃L[ɂ}b`OȂ
	b[0]=b[1]=b[2]=b[3]=20;
	for(i=0; i<n; i++)
	{
		if((KeyBuf[i]<=L9)||(KeyBuf[i]==L0)||(KeyBuf[i]==L5))	b[bn++]=KeyBuf[i];
		else											s[sn++]=KeyBuf[i];
	}

	if(sn==0)	goto BOIN;

	Code0=KeyCodeAsc[s[0]/8][s[0]%8];
	
	if((bn==2)&&(b[0]==L7)&&(b[1]==L5))
	{
		if((sn==2)&&(s[0]!=R4))
		{
			if(s[0]==R2)	 PushAsc(uS);				// s'
			else 
			{
				if(s[1]==R2)	 PushAsc(uI);			// in'
				PushAsc(uN); 
				if(s[1]==R3)	goto APSP;			// n't
			}	
			s[0]=R3;
		}
	APSP:
		PushCode10(36);							// '
		switch(s[0])
		{
		case R0:	Code0=uR;	Code1=uE;	break;	// 're 
		case R1:	Code0=uT;				break;	// 't 
//		case R2:	Code0=uS;				break;	// 's 
		case R3:	Code0=0;					break;	// ' 
		case R4:	Code0=uV;	Code1=uE;	break;	// 've 
		case R5:	Code1=uL;				break;	// 'll 
//		case R6:	Code0=uD;				break;	// 'd 
//		case R7:	Code0=uN;				break;	// 'n 
		}
		goto SPR;
	}
	if((bn==2)&&(b[1]==L5)&&(1<=sn)&&(b[0]!=L1)&&(b[0]!=L9))	// in on of if
	{
		if(b[0]==L3)	// o+
		{
			if(sn==1)
			{
				switch(s[0])
				{
				case R4:
				case R2:
				case R3:	Code1=uO;	
					ME:
						Code2=uM;				goto ERET;		// some come home
				case R8:
				case R1:
				case R6:								break;		// to do go 
				case R5:								goto DOP;	// lop
				default:	goto UOI;
				}
				Code1=uO;
				goto SPR;
			}
			else if(2<=sn)
			{
				if((sn==3)&&(s[2]==R3))
				{
					Code0=uO;	Code1=uB;	goto RET;	// ob
				}
				if(s[1]==R0)
				{
					switch(s[0])
					{
					case R9:	goto FOR;										// for
					case R7:
					case R1:	PushAsc3(uF,uR,uO);	
							if(s[0]==R1)
							{
								Code0=uN;	Code1=uT;						// front 
							}
							else 
							{
								Code0=uM;									// from 
							}		
							goto SPR;
					case R4:	Code0=uO;	Code1=uV;	Code2=uE;	Code3=uR;
							goto RET;										// over
					case R6:	PushAsc(uD);	Code0=uR;				goto DOP;	// drop
					case R8:	PushAsc3(uG,uR,uO);								// group
							Code0=uU;	Code1=uP;				goto RET;										// group
					case R3:
					case R2:	PushAsc2(uM,uO);								
							if(s[0]==R2)
							{
								Code0=uU;									// mouse
							SE:
								Code1=uS;	goto ERET;
							}
							else 
							{
								Code0=uN;	goto TH;							// month
							}
					default:	goto UOI;
					}
				}
				else if(s[1]==R5)
				{
					if(s[0]==R9)									// for
					{
					FOR:
						Code0=uF;	Code1=uO;	Code2=uR;
						if(s[1]==R0)	goto SPR;
					FOK:											// for(
						if(Caps)	CapsToggle();	
						Ka=1;	goto RET;
					}
					else if(s[0]==R3)								// o'clock
					{
						PushAsc(uO);	PushCode10(36);	PushAsc(uC);
						Code0=uL;	Code1=uO;	goto CK;
					}
					else if((s[0]==R6)||(s[0]==R1))				// don't  doesn't 
					{
						PushAsc2(uD,uO);		
						if(s[0]==R1)	PushAsc2(uE,uS);
					NT:	PushAsc(uN);								// n't 
						s[0]=R1;
						goto APSP;
					}
					else if(s[0]==R7)								// won't 
					{
						PushAsc2(uW,uO);		goto NT;
					}
					else if(s[0]==R4)								// love
					{
						Code0=uL;	goto OVE;
					}
					else if(s[0]==R8)								// God
					{
						PushAscL(uG);		Code0=uO;	Code1=uD;	goto RET;
					}
					else 										// only 
					{
						Code0=uO;	Code1=uN;	
					ONLY:
						Code2=uL;	Code3=uY;	
						goto SPR;
					}
				}
				else if(s[1]==R7)
				{
					if(s[0]==R1)
					{
						if(s[2]==R5)
						{
							PushAsc3(uT,uO,uI);	
							PushAsc3(uL,uE,uT);	return;			// toilet
						}
						PushAsc(uN);		goto UOI;				// not 
					}
					if(s[0]==R3)									// once
					{
						Code0=uO;
					NCESP:
						Sp=1;
					NCE:
						Code1=uN;	Code2=uC;
						goto ERET;								// ance ence
					}
					Code0=uO;	Code1=uP;	Code2=uE;	Code3=uN;// open
					goto RET;
				}
				else if(s[1]==R2)
				{
					PushAsc(uS);									// stop
				DOP:	PushAsc(Code0);	Code0=uO;
					Code1=uP;		goto RET;
				}
				else if((s[0]==R1)&&(s[1]==R3))
				{
					PushAsc2(uB,uO);	
					if(sn!=2)	goto TTLE;						// bottle
					Code0=uY;	goto RET;						// boy 
				}
				else if(s[1]==R4)
				{
					if(s[0]==R3)
					{
						Code0=uO;	goto HRET;					// oh
					}
					if(s[0]==R1)									// both
					{
						Code0=uB;	Code1=uO;	goto TH;
					}
					if(s[2]==R0)									// move
					{
						Code0=uM;	
					OVE:
						Code1=uO;	Code2=uV;	goto ERET;
					}
					PushAsc(Code0);	Code0=uH;	goto DOP;		// shop
				}
				else if((s[0]==R4)&&(s[1]==R6))					// hope
				{
					Code1=uO;	Code2=uP;	goto ERET;
				}
				else 
				{
					if(s[1]==R8)
					{
						if(s[0]==R7)	{ Code0=uO;	goto NTO; }		// onto 
						if(s[0]==R6)								// job
						{
							Code0=uJ;	Code1=uO;	Code2=uB;	
							goto RET;
						}
						if(s[0]==R1)		goto DOP;				// top
					}
					PushAsc(uO);	Code0=uF;
					if(s[0]==R2)		{ Code1=uF;	goto RET; }		// off 
					else if(s[0]==R6)								// office
					{
						PushAsc(uF);
					ICE:
						Code1=uI;	Code2=uC;	
						goto ERET;
					}
					else 		
					{ 
						Code1=uT;	Code2=uE;	Code3=uN;		// often 
					}							
				}
				goto SPR;
			}
		}
		else if(b[0]==L4)	// u+
		{
			if(sn==1)
			{
				switch(s[0])
				{
				case R7:	PushAsc(uU);	Code1=uD;		goto ER; 	// under
				case R0:	Code1=Code2=uO;	Code3=uM;	break;		// room
				case R2:	
				case R6:	
				USE:		Code0=uU;	Code1=uS;
						if(s[0]==R6)	goto ERET;					// us use
													break;
				case R8:	Code1=uU;	Code2=uY;		break;		// guy
				default:
				OOK:		Code1=Code2=uO;	Code3=uK;				// took look cook hook
				}
				goto RET;
			}
 			else if((s[1]==R5)&&((s[0]==R2)||(s[0]==R3)||(s[0]==R7)||(s[0]==R8)))
			{
				if(s[0]==R8)
				{
					PushAsc2(uW,uE);		goto RENT;				// weren't 
				}
				else 
				{ 
					if(s[0]==R2)	{ PushAsc(uS);	Code0=uH; }		// shouldn't 
					else if(s[0]==R7)		Code0=uW;				// wouldn't 
					PushAsc2(Code0,uO);
					PushAsc3(uU,uL,uD);							// couldn't 
				}
				goto NT;
			}					
			else if(((s[0]==R2)||(s[0]==R7))&&(s[1]==R0))
			{
				if(s[0]==R7)	Code0=uM;							// such much
				Code1=uU;	Sp=1;
			CH:	Code2=uC;	Code3=uH;
				goto RET;
			}
			else if((s[0]==R4)&&(s[1]==R0))						// very
			{
				Code0=uV;	Code1=uE;	Code2=uR;	goto YSPR;
			}
			else if(s[0]==R6)										// up
			{
				if(s[1]==R9)
				{
					Code0=uR;	Code1=uU;	goto PT;				// rupt
				}
				PushAsc(uU);
				Code0=uP;
				if(s[2]==R8)
				{
					Code1=uP;	goto ER;							// upper
				}
				else if(s[1]==R8)
				{
					Code1=uO;	Code2=uN;	goto SPR;			// upon 
				}
				goto RET;
			}
			else if(s[1]==R7)
			{
				PushAsc2(uU,uN);
				Code0=uI;
				if(s[0]==R3)	goto RET;							// uni
				if(s[0]==R1)	{ Code1=uT;	goto RET; }				// unit
				Code1=uV;										// univer
			ER:
				Code2=uE;	Code3=uR;
				goto RET;
			}
			else if(s[1]==R6)										// duct
			{
				Code0=uD;	goto UCT;
			}
			else if(sn==3)
			{
				if((s[1]==R3)&&(s[2]==R0))							// umbrella
				{
					PushAsc3(uU,uM,uB);	PushAsc3(uR,uE,uL);
					Code0=uL;	Code1=uA;
				}
				else if(s[2]==R3)									// buy
				{
					Code0=uB;	Code1=uU;	Code2=uY;
				}
				else if(s[0]==R3)									// club
				{
					PushAsc(uC);	Code0=uL;	goto DUB;
				}
				else if(s[1]==R4)									// truth
				{
					if(s[0]==R2)	{ Code0=uR;	goto DUB; }			// rub
					Code1=uR;	Code2=uU;	goto TH;
				}
				else if(s[1]==R2)									// struct
				{
					PushAsc2(uS,uT);	
					Code0=uR;
					if(s[2]==R5)	Code1=uI;						// strict
					else 
					{
					UCT:
						Code1=uU;	
					}
					goto CTR;
				}
				else 											// excuse
				{
					PushAsc3(uE,uX,uC);	Code2=uE;	goto USE;
				}
				goto RET; 
			}
			else if(s[0]==R3)										// uh
			{
				Code0=uU;	
			HRET:
				Code1=uH;	goto RET;
			}
			else 
			{
				if((s[0]==R1)&&(s[1]==R3))	{ Code0=uB;	goto OOK; }		// book
				if(s[1]==R2)		Code0=uP;							// pub
			DUB:
				PushAsc(Code0);
				if((s[0]==R2)&&(s[1]==R4)&&(sn==2))
					{ Code0=uH;	goto OOK; }							// shook
				PushAsc(uU);
				if((s[0]==R1)&&(s[1]==R0))	{ PushAsc2(uR,uN); return; }	// turn
				Code0=uB;											// sub tub hub
			RET:
				Ret=1;		goto PushA;
			}
		}
		else if(b[0]==L2)	// i+
		{
			if(sn==1)
			{
				switch(s[0])
				{
				case R0:	Code1=uI;	Code2=uS;	goto ERET;				// rise
				case R8:	Code1=uI;	Code2=uR;	Code3=uL;	goto RET;	// girl
				case R4:	Code1=uE;	Code2=uL;	Code3=uP;	goto RET;	// help
				case R3:
				case R5:
				case R6:
				IPLUS:
						PushAscL(uI);	
						if(s[0]==R3)	{ Code0=0;	goto SPR; }			// I 
						PushCode10(36);
						if(s[0]==R7)			Code0=uM;				// I'm 
						else if(s[0]==R6)		;						// I'd
						else if(s[0]==R4)	
							{ Code0=uV;	Code1=uE; }					// I've
						else 				Code1=uL;				// I'll 
						goto SPR;
				default:	goto UOI;									// it is in if 
				}
			}
			else if(2<=sn)
			{
				if((s[0]==R6)&&(s[1]==R7))
				{
					if(s[2]==R8)	PushAsc2(uA,uP);						// appoint
					PushAsc(uP);
					if(s[2]==R0)										// pretty 
					{
						PushAsc(uR);	Code0=uE;	Code1=Code2=uT;	
					YSPR:
						Code3=uY;
						goto SPR;
					}
					Code0=uO;	Code1=uI;		goto NTR;			// point
				}
				if(s[1]==R0)
				{
					if((s[0]==R4)||(s[0]==R7))		goto IPLUS;			// I've I'm 
					if(s[0]==R1)										// time
					{
						Code1=uI;	goto ME;
					}
					if(s[0]==R6)										// middle 
					{
						PushAsc3(uM,uI,uD);
						Code0=uD;	Ret=Sp=1;	goto LE;
					}
					if(s[0]==R2)										// like
					{
						Code0=uL;	Code1=uI;	goto KE;
					}
					if(s[0]==R3)										// rich
					{
						Code0=uR;	Code1=uI;	goto CH;	
					}
					if(s[0]==R8)
					{
						Code0=uM;	goto INE;						// mine
					}
				}
				if((s[0]==R1)&&(s[1]==R4))								// rhythm the_
				{
					Code0=uT;	Code1=uH;
					if(sn==2)	{ Code2=uE;	Sp=1; }
					else 
					{
						PushAsc3(uR,uH,uY);
						Code2=uM;
					}
					goto RET;
				}
				if(s[1]==R9)
				{
					if(s[0]==R7)
					{
						if(s[2]==R5)	{ Code0=uZ;	goto INE; }			// zine
						else 	{ PushAsc3(uF,uI,uN);	goto ISH; }		// finish
					}
					if(s[0]==R6)										// kept
					{
						if(sn==3)
							{ PushAsc(uK);	Code0=uN;	goto IFE; }	// knife
						Code0=uK;			goto EPT;
					}
					if((s[0]==R1)&&(sn==2))	Code0=uF;				// fine tine 
					if((s[0]==R2)&&(sn==3))	Code0=0;					// ine
					goto INE;										// cine gine sine
				}
				if(((s[0]==R2)||(s[0]==R3))&&(s[1]==R4))					// shine chine
				{
					PushAsc(Code0);	
					Code0=uH;	
					if(s[2]==R5)
					{
						if(s[0]==R2)
							{ Code0=uI;	Code1=uZ;	goto ERET; }		// size
						Code0=uL;									// cline
					}
					goto INE;
				}
				if(s[1]==R8)
				{
					if(s[0]==R2)										// since
					{
						PushAsc(uS);		Code0=uI;	goto NCESP;
					}
					if(s[0]==R1)										// type
					{
						Code0=uT;	Code1=uY;	Code2=uP;
						goto ERET;
					}
					if(s[0]==R7)										// into
					{
						Code0=uI;	
					NTO:
						Code1=uN;	Code2=uT;	Code3=uO;
					}
					else											// wish
					{
						PushAsc(uW);		goto ISH;
					}
				}
				if(s[1]==R5)
				{
					if(s[0]==R4)										// life
					{
						Code0=uL;	
					IFE:
						Code1=uI;	Code2=uF;
						goto ERET;
					}
					if(s[0]==R6)										// didn't 
					{
						PushAsc3(uD,uI,uD);		goto NT;
					}
					if(s[0]==R7)
					{
						Code0=uW;	Code1=uI;	goto TH;					// with 
					}
					if((s[0]==R9)||(s[0]==R2))
					{
						if(s[0]==R9)	{ Code0=uI;	Code1=uF;	goto FOK; }	// if( 
						if(Caps)	CapsToggle();
						Sp=1;
						Code0=uE;	Code1=uL;	Code2=uS;				// else 
					}
					else if(s[0]==R8)		{ Code0=uW;	goto INE; }			// wine
					else if(s[0]==R3)
					{
						Code0=uL;										// line
					INE:
						Code1=uI;	Code2=uN;
					}
					else 												// little 
					{
						PushAsc2(uL,uI);	Sp=1;
					TTLE:
						Code0=Code1=uT;	Code2=uL;
					}
				ERET:
					Code3=uE;	goto RET;
				}
				else if(s[2]==R3)									// bird
				{
					Code0=uB;	Code1=uI;	Code2=uR;	Code3=uD;
					goto RET;
				}
				else if(s[1]==R7)									// inter enter
				{
					if(s[0]==R4)	{ Code0=uW;	goto IFE; }			// wife
					if(s[0]==R1)		PushAsc(uI);	
					else 			PushAsc(uE);
					Code0=uN;	goto TER;
				}
				else if((s[0]==R1)&&(sn==2))						// its it's 
				{
					PushAsc2(uI,uT);
					Code0=uS;
					if(s[1]==R3)	PushCode10(36);
				}
				else if(s[1]==R3)									// isn't 
				{
					if(s[2]==R0)	
						{ Code0=uR;	Code1=uI;	goto SK; }		// risk
					PushAsc2(uI,uS);		goto NT;
				}
				else if(((s[0]==R9)&&(s[1]==R0))||(s[1]==R2))		// fire tire
				{
					if(s[2]==R5)	Code0=uS;						// sire
					Code1=uI;			goto RE;
				}
				else if(s[1]==R6)
				{
					if(s[0]==R2)		goto PER;					// person
					if(s[2]==R0)	{ Code0=uV;	goto INE; }			// vine
					Code0=Code3=uD;	Code1=Code2=uE;	goto RET;	// deed
				}
			}
			goto SPR;
		}
UOI:
		Code1=Code0;
		Code0=KeyCodeAsc[b[0]/8][b[0]%8];
		goto SPR;
	}
	if((bn==2)&&(b[0]==L8)&&(b[1]==L0)&&(1<=sn))	// as at am and are
	{
		if((sn==1)&&(s[0]==R3))						// came
		{
		AME:
			Code1=uA;	goto ME;
		}
		else if((sn==1)&&(s[0]==R4))
		{
		AVE:
			Code1=uA;	Code2=uV;	goto ERET;		// have
		}
		else if((sn==2)&&(((s[0]==R2)&&(s[1]==R8))||(((s[0]==R7)||(s[0]==R8))&&(s[1]==R0))
		||(((s[0]==R2)||(s[0]==R3))&&(s[1]==R9))||((s[0]==R2)&&(s[1]==R6))||((s[0]==R1)&&(s[1]==R7))))
		{
			if((s[0]==R1)||(s[1]==R9))		;			// take cake sake
			else if(s[1]==R6)	Code0=uW;				// wake
			else if((s[0]==R2)||(s[0]==R8))goto AME;	// same game
			else 			Code0=uM;				// make
		AKE:
			Code1=uA;	
		KE:
			Code2=uK;	goto ERET;
		}
		else if(((s[0]==R1)&&(((R7<=s[1])&&(s[1]<=R9))||(s[1]==R5)))
											// tact tect fact ffect trast ain't act
			||((s[0]==R3)&&(s[1]==R6)))						// pact
		{
			Code1=uA;	
			if(s[1]==R9)
			{
				if(s[2]==R5)	{ PushAsc(uF);	goto FECT; }		// ffect
				Code0=uF;									// fact
			}
			else if(s[1]==R8)
			{
				Code0=uT;									// tact
				if(s[2]==R5)		goto ECT;					// tect
			}
			else if(s[1]==R6)		Code0=uP;					// pact
			else 				Code0=0;						// act
			if(s[2]==R0)	{ PushAsc(uT);	Code0=uR; }			// tract trast
			if(s[1]==R7)
			{
				if(s[2]==R5)
					{ PushAsc2(uA,uI);	Code1=0;	goto NT; }	// ain't 
				goto ST;										// trast
			}
		CTR:	Ret=1;
		CT:	Code2=uC;	Code3=uT;
			goto PushA;
		}
		else if(((s[0]==R4)&&(s[1]==R6))||((s[0]==R2)&&(s[1]==R4)))
		{
			if(s[2]==R0)								// shake
			{
				PushAsc(uS);	Code0=uH;	goto AKE;
			}
			if(s[2]==R5)
			{
				if(s[0]==R4)	Code0=uG;				// gave
				goto AVE;							// save
			}
			if(s[0]==R4)	Code0=uD;					// hadn't
			else 		Code0=uS;					// hasn't 
			PushAsc3(uH,uA,Code0);		goto NT;
		}
		else if((s[0]==R6)&&(s[1]<=R8))
		{
		PER:
			PushAsc3(uP,uE,uR);						// perfect
			if(s[1]==R6)		goto ION;				// person
			if(s[1]==R8)								// perhap
			{
				Code0=uH;	Code1=uA;	Code2=uP;	Code3=uS;
				goto SPR;
			}
		FECT:
			Code0=uF;
		ECT:
			Code1=uE;	goto CTR;
		}
		else if(s[1]==R5)
		{
			if(s[0]==R3)										// can't
			{
				PushAsc2(uC,uA);		goto NT;
			}
			else if(s[0]==R4)									// haven't 
			{
				PushAsc3(uH,uA,uV);	goto ENT;
			}
			else if(s[0]==R7)									// wasn't
			{
				PushAsc3(uW,uA,uS);	goto NT;
			}
			else if(s[0]==R8)									// large
			{
				PushAsc3(uL,uA,uR);
				Code0=uG;	goto ERET;
			}
			else 											// away always
			{
				PushAsc(uA);
				if(s[0]!=R6)	PushAsc(uL);
				if(s[0]==R2)	{ Code1=uO;	goto SPR; }			// also
				if(s[0]==R9)	Code3=uS;
				Code0=uW;	Code1=uA;	Code2=uY;
				goto SPR;
			}
			goto RET;
		}	
		else if((sn==2)&&(s[0]==R3)&&(s[1]==R7))				// nect
		{
			Code0=uN;	goto ECT;
		}
		else if((s[1]==R2)&&((s[2]==R0)||(s[2]==R5)))			// task
		{
			if(s[2]==R0)	Code0=uM;							// mask
			Code1=uA;	
		SK:
			Code2=uS;	Code3=uK;
			goto RET;
		}
		else if(((s[0]==R1)&&(s[1]==R4))||((s[0]==R4)&&(s[1]==R7)))
		{
			if(s[0]==R1)	Code0=uB;							// bath
			else
			{
				Code0=uP;									// path
				if(s[2]==R5)	{ Code0=uW;	goto AVE; }			// wave
			}
			Code1=uA;
		TH:	Th=1;
			goto RET;
		}
		else if(s[2]==R9)										// many
		{
			PushAsc(uM);	Sp=1;
		}
		else if((s[0]==R6)&&(s[1]==R0))						// made
		{
			Code0=uM;	Code1=uA;	Code2=uD;	goto ERET;
		}
		else if((s[1]==R3)&&(s[2]==R5))						// sale tale
		{
			Code1=uA;	Code2=uL;	goto ERET;
		}

		PushAsc(uA);
		if(2<=sn)
		{
			if(s[0]==R1)
			{
				if(s[1]==R0)	
				{
				RENT:
					PushAsc(uR);
				ENT:
					PushAsc(uE);		goto NT;					// aren't 
				}
				else if((sn==2)&&(s[1]==R2))	;				// at
				else 
				{
					PushAsc(uB);
					if(sn==2)	goto OUTR;					// about
					else 		return;						// ab
				}
				goto RET;
			}
			else if(s[1]==R0)
			{
				if(s[0]==R3)
				{
					Code0=uM;								// am 
				}
				else if(s[0]==R4)								// above
				{
					Code0=uB;	Sp=1;	goto OVE;
				}
				else if(s[0]==R2)								// ask
				{
					Code0=0;		goto SK;
				}
				else 
				{
					PushAsc3(uD,uD,uR);	goto ESS;			// address
				}
			}
			else if((s[0]==R8)&&(s[2]==R0))					// agree
			{
				Code0=uG;	Code1=uR;	Code2=uE;	goto ERET;
			}
			else 
			{
				if(s[1]==R8)		Code1=uY; 					// any
				else if(s[0]==R3)	Code0=uH;					// ah
				goto RET;									// as ag
			}
		}
		else 
		{
			if(s[0]==R8)										// again
			{ 
				Code1=uA;	Code2=uI;	Code3=uN;	goto RET;
			}
			if(s[0]==R9)	
			{ 
			TER:
				Code1=uT;	goto ER;
			}												// after
			if(s[0]==R7)		Code1=uD;						// and 
			else if(s[0]==R5)	Code1=uL;						// all
			else if(s[0]==R0)	Code1=uE;						// are 
			else if(s[0]==R6)		goto RET;					// ad
		}
	SPR:
		Sp=1;
		goto RET;
	}

	if((bn==2)&&(b[0]==L2)&&(b[1]==L4)&&(2<=sn))
	{
		if(sn==2)
		{
			if((s[0]==R2)&&(s[1]==R0))			Code0=uK;	// kick
			else if(((s[0]==R2)&&(s[1]==R3))||((s[0]==R7)&&(s[1]==R8)))
				;										// sick nick
			else if((s[0]==R3)&&(s[1]==R5))
				{ PushAsc(Code0);	Code0=uL; }				// click
			else 	goto PASS;
		}
		else if(sn==3)
		{
			if(s[2]==R3)								{ PushAsc(uS);	Code0=uT; }	// stick
			else if((s[0]==R6)&&(s[2]==R8))							Code0=uP;	// pick
			else if((s[0]==R1)&&(s[1]==R4)&&(s[2]==R0))	{ PushAsc(uT);	Code0=uH; }	// thick
			else if((s[0]==R6)&&(s[1]==R8)&&(s[2]==R0))	{ PushAsc(uQ);	Code0=uU; }	// quick
			else 	goto PASS;
		}
		else if((s[3]==R0)&&(s[2]==R3))				{ PushAsc(uB);	Code0=uR; }	// brick
		else 	goto PASS;
		Code1=uI;	
	CK:
		Code2=uC;	Code3=uK;	goto RET;
	}	
	PASS:		
	if(sn==4)
	{
		if(R6<=s[0])
		{
			if(s[0]==R7)	goto WH;
			else if((s[3]==R9)||((bn==0)&&(s[3]==R0)))
			{
			YOU:
				PushAsc2(uY,uO);	Code0=uU;
				if(sn==3)	goto RET;					// you			
				if(s[3]==R0)	{ Code1=uR;	goto RET; }		// your
				Code1=uN;	Code2=uG; 					// young
			}
			else if(bn==0)
			{
				Code0=uP;	goto AMPM;					// p.m.
			}
			else
			{
				Code0=uA;	Code1=Code2=uP;	Code3=uR;	// appr appl
				if(s[3]==R5)	Code3=uL;
			}
		}
		else if(R0<=s[3])
		{
			if(s[0]==R2)									// isl
			{
				if(bn==0)								// OK
				{
					PushAscL(uO);		PushAscL(uK);		return;
				}
				Code0=uI;	Code1=uS;	Code2=uL;
			}
			else 
			{	
				Code0=Code1=uB;							// bb
				if(s[3]==R5)
				{
					if(bn==0)							// Perky
					{
						PushAscL(uP);
						Code0=uE;	Code1=uR;	Code2=uK;	
					YRET:
						Code3=uY;
						goto RET;
					}
					else if((bn==2)&&(b[0]==L1)&&(b[1]==L3))
					{
						PushAsc(uB);						// block
						Code0=uL;	Code1=uO;	goto CK;
					}
					else 		Code2=uL;				// bbl
				}
			}
		}
		else 
		{
			if(bn)	
			{
				PushAsc(uS);		goto QU;				// squ
			}
			else 
			{
				PushAsc3(uW,uO,uR);					// world
				Code0=uL;	Code1=uD;	goto RET;
			}
		}
		goto PushA;
	}
	
	if((bn==3)&&(b[0]==L2)&&(b[2]==L4))		// +ight
	{
		if((sn==1)&&(s[0]==R8))	Code0=uE;	// eight 
		else if(sn==2)
		{
			if(((s[0]==R1)&&(s[1]>=R0))||((s[0]==R8)&&(s[1]==R0))||((s[0]==R4)&&(s[1]==R5))
			||((s[0]==R1)&&(s[1]==R8))||((s[0]==R7)&&(s[1]<=R9))||((s[0]==R3)&&(s[1]==R6)))
			{									// tr tl fr hl tg gn cd
				if((s[0]==R1)&&(s[1]>=R0))			// wrote //wrought
				{
					PushAsc2(uW,uR);
					//if(s[1]==R5)	{ sn=0;	goto BOIN; }
					Code0=uO;	Code1=uT;	goto ERET;
				}
				else if(s[0]==R7)					// neighbor
				{
					PushAsc(uN);
					PushAsc3(uE,uI,uG);
					Code0=uH;	Code1=uB;	Code2=uO;	Code3=uR;
				}
				else 
				{
					if(s[0]==R4)					// laugh
					{
						PushAsc(uL);	Code0=uA;	goto UGH;
					}
					if(s[0]==R8)	Code0=uR;		// rough
					PushAsc(Code0);				// cough tough
					goto OUGH;		
				}
				goto RET;
			}
			else if((s[0]==R2)&&(s[1]==R8))		// sigh
			{
				Code0=uS;	goto IGH;
			}
			else if((s[0]==R8)&&(s[1]==R5))		// weigh
			{
				PushAsc(uW);	
				Code0=uE;	
			IGH:	Code1=uI;	
			GH:	Code2=uG;	Code3=uH;
				goto RET;
			}
			else if(s[1]==R2)						// taught 
			{
				PushAsc(uT);	goto IGHT; 
			}
		}
		else if(sn==3)
		{
			if((s[0]==R1)&&(s[1]==R4))	
			{
				PushAsc2(uT,uH);					// through though
				if(s[2]==R0)	PushAsc(uR);
			OUGH:
				Code0=uO;	
			UGH:
				Code1=uU;	goto GH;
			}
		}
	}
	
	if(sn==1)	;
	else if(sn==2)
	{
		if((s[0]==R1)&&(s[1]==R3))		Code0=uB;			// b
		else if(s[1]==R0)
		{
			if(s[0]==R2)			Code0=uK;				// k
			else if(s[0]==R7)		Code0=uM;				// m
			else if(s[0]==R4)
			{
				Code0=uV;								// v
				if((bn==2)&&(b[0]==L1)&&(b[1]==L0))
				{
					Code0=0;		goto AVE;				// ave
				}
			}
			else 	goto S2;
		}
		else if(s[1]==R5)
		{
			if((s[0]==R9)&&(bn==0))	Code0=uX;			// x
			else if(s[0]==R4)			Code0=uZ;			// z
			else if(s[0]==R7)			Code0=uW;			// w
			else 	goto S2;
		}
		else if(s[1]==R6)
		{
			if(s[0]==R2)		{ Code0=uS;	Code1=uP; }		// sp
			else if(s[0]==R3)	{ Code0=uC;	Code1=uK; }		// ck
			else			{ Code0=uP;	Code1=uH; }		// ph
		}
		else if(s[1]==R7)
		{
			if(s[0]==R6)			Code0=uP;				// p
			else if(s[0]==R4)		{ Code0=uK;	Code1=uL; }	// kl
			else
			{
				Code1=Code0;								// tt cc
				if((s[0]==R1)&&(bn==2)&&(b[1]==L3)&&(b[0]==L1))
					PushAsc(uA);							// attack
				else if((Code0==uC)&&(((b[2]==L6)&&(b[3]==L0))||((b[0]==L4)&&(bn<=2))))
					PushAsc(uO);							// occasion occu occur
				
			}
		}
		else if(s[1]==R8)
		{
			if(s[0]==R6)			Code0=uY;				// y
			else if(s[0]==R7)		Code0=uJ;				// j
			else if(s[0]==R1)	
			{
			CT2:
				Code0=uC;	Code1=uT; 					// ct
			}
			else 				Code1=uS;				// ss
		}
		else if(s[1]==R9)
		{
			Code0=uF;
			switch(s[0])
			{
			case R1:		Code2=uT;						// ft
				if(bn==1)
				{
					Code1=uI;	Ret=1;
				FT:
					Code2=uF;	Code3=uT;	
					switch(b[0])
					{
					case L0:	Code1=uA;						// shaft
					case L2:	Code0=uW;						// swift
					case L1:	if(b[0]!=L2)	Code0=uH;			// shift
							PushAsc(uS);				break;
					case L8:	Code0=uG;				break;	// gift
					case L5:	Code0=uL;				break;	// lift
					case L6:	PushAsc(uD);						// draft
					case L3:	if(b[0]==L3)	PushAsc(uC);			// craft
							Code0=uR;	Code1=uA;	break;
					case L7:	Ret=0;					break;	// fifty
					case L4:	Code3=0;		Th=1;				// fifth
					}
					goto PushA;
				}								break;
			case R2:		Code1=uF;				break;	// ff
			case R6:		Code0=uP;	Code1=uT;	break;	// pt
			case R8:		Code0=uG;	Code1=uH;	break;	// gh
			case R7:		Code1=uF;	Code2=uL;			// ffl
				if(bn==0){ Code1=uI;	goto ERET; }			// file
			}
		}
		else
		{
		S2:
			Code1=KeyCodeAsc[s[1]/8][s[1]%8];
			if((s[0]==R1)&&(s[1]==R2))						// st 
			{
				Code0=uS;	Code1=uT;
			}
			if((b[0]==L1)&&(b[1]==L8)&&(b[2]==L0)&&(s[0]==R1))
			{
				if(s[1]==R4)
				{
					Th=1;	goto BOIN;					// earth
				}
				if(s[1]==R5)	goto SEARCH;					// early
			}
			else if((s[0]==R8)&&(s[1]==R5)&&(bn==2)&&(b[0]==L7)&&(b[1]==L8))
			{
				PushAscL(uE);		PushAsc(uN);				// English 
			}
			else if((s[0]==R2)&&(s[1]==R3)&&(b[0]==L1)&&(b[1]==L4)&&(b[2]==L0))
			{
				PushAsc(uE);								// escape
			}
		}
	}
	else if(sn==3)		// str stl br bl thr spr spl pr pl scr scl sch your
	{					// shr shl sk  wh pp mm chr chl ckl gn ctr ctl ght kl kt
		if(s[0]==R2)				// spr spl  scr scl sch shr shl sk sw
		{
			if(R8<=s[1])
			{
				if(s[1]==R8)
				{
					Code0=Code1=uG;
					if(s[2]==R5)
					{
						if(bn==0)	{ Code0=uL;	Code1=uS; }	// ls
						else 		Code2=uL;				// ggl
					}
					goto PushA;
				}
				if(s[2]==R0)	Code1=uK;					// sk
				else if(bn==0)	{ Code1=uI;	Code2=uX; }	// six
				else			{ Code0=uW;	Code1=uR; }	// wr
				goto PushA;
			}
			if(s[1]==R6)
			{
				if(bn==0)	
				{
					Code0=uD;	Code1=uS;				// ds
					if(s[2]==R0)							// desk
					{
						Code1=uE;	goto SK;
					}
					goto PushA;
				}
				else 	    Code1=uP;						// spr spl
			}
			else if(s[1]==R3)
			{
				Code1=uS;
				if(s[2]==R6)		Code0=uP;				// ps
				else if((s[2]==R0)&&(bn==0))
				{
					Code0=uK;	goto PushA;				// ks
				}
				else
				{
					if((s[2]==R5)&&((bn==0)||((bn==1)&&(b[0]==L6))))
					{
						PushAsc2(uS,uE);					// self
						Code0=uL;	Code1=uF;
						if(bn)							// selves
						{
							Code1=uV;	Code2=uE;	Code3=uS;
						}
						goto RET;
					}
				 	Code1=uC;							// sch scr scl
				} 
			}
			else if(s[1]==R4)
			{
				if(bn==0)
				{
					PushAsc(uF);	Code0=uI;
					if(s[2]==R0)		goto VE;				// five
					else 								// first
					{
						Code1=uR;	goto ST;
					}
				}
				Code1=uH;								// shr shl
			}
		}
		else if(s[2]==R3)	
		{
			if((b[0]==L1)&&(b[1]==L8))							// kitchen
			{
				PushAsc3(uK,uI,uT);
				Code0=uC;	Code1=uH;	goto PushA;
			}
			Code0=uE;	Code1=uA;							// each
			if(bn)	Code3=uT;
			switch(b[0])
			{
			case L1:	if(b[1]==L3)	{ Code0=uB;	Code2=uS; goto ERET; }	// base
											break;			// teach
			case L6:	if(bn==1)
					{
						Code0=uO;	Code1=uU;	break;		// touch
					}
					Code3=uP;	Code1=uT;
					if(b[1]==L7)	Code0=uI;					// pitch
					else 		Code0=uA;		break;		// patch
			case L8:
			case L2:
			case L5:
			case L3:	Code3=uW;	Code1=uT;					// watch
					if(b[0]==L3)	Code3=uC;					// catch
					if(b[0]==L8)	Code3=uM;					// match
					if(b[0]==L2)	
					{
						PushAsc(uS);	
						if(bn==2) { PushAsc(uT);	Code3=uR; }	// stretch
						else 		Code0=uI;				// switch
						break;
					}
					Code0=uA;				break;
			case L0:	Code3=uR;				break;			// reach
			case L7:	Code2=uS;	Code3=uY;	goto RET;		// easy
			case L4:	Code1=0;					break;			// tech
			}
			if(Code3)	PushAsc(Code3);
			goto CH;	
		}
		else if(s[0]==0)		;
		else if(s[1]==R2)						
		{
			if(s[2]==R8)	{ Code1=uS;	goto PushA; }		// ts
			else if((bn==0)&&(s[2]==R5))					// soft
			{
				Code0=uS;	Code1=uO;	goto FT;
			}
			else if(s[2]==R4)								// push
			{
				Code0=uP;	Code1=uU;	Code2=uS;	Code3=uH;
			}
			else if(s[2]==R9)								// sign
			{
				Code0=uS;	
			IGN:
				Code1=uI;	Code2=uG;	Code3=uN;
			}
			else		{ Code0=uS;	Code1=uT; }			// str stl
		}
		else if(s[0]==R6)		
		{
			if(s[1]==R8)
			{
				if(s[2]==R5)	{ Code0=uD;	Code1=uG; }	// dg
				else 		
				{ 
				QU:
					Code0=uQ;	Code1=uU;		 	// qu
				}
				goto PushA;
			}
			else if(s[2]==R8)							// pp
			{
				if(b[0]==L5)	{ bn=0;	Sp=1; }			// you_
				if(bn==0)	goto YOU;
				Code0=Code1=uP;
				if((bn==2)&&(b[0]==L1)&&(b[1]==L3))		// pack
				{
				ACK:
					Code1=uA;	goto CK;
				}
				if((b[0]==L2)&&(b[1]==L6)&&(b[2]==L0))	// paign
				{
					PushAsc(uP);	Code0=uA;	Ret=1;	goto IGN;
				}					
				if((b[0]==L1)&&(b[2]==L0))	PushAsc(uA);	// appear appeal
			}
			else if(s[1]==R9)
			{
				if(bn==0)	
				{
					Code0=uL;	Code1=uE;	goto FT;	// left
				}
				Code0=uK;	Code1=uN;
				if((bn==1)&&(b[0]==L3))
				{
					Code2=uO;	Code3=uB;	Ret=1;	// knob
				}
				goto PushA;							// kn
			}
			else  Code0=uP;							// pr pl
		}
		else if(s[1]==R3)
		{
			if(s[2]==R4)				    				// tch
			{
				Code1=uC;	
			}
			else 
			{
				Code0=uB;							// br bl
				if((bn==0)&&(s[2]==R5))				// bs
				{
					Code1=uS;		goto RET;
				}
			}
		}
		else if(s[1]==R4)	
		{
			if(bn==0)
			{
				Code1=uE;
				if(s[0]==R3)							// chr chl
				{
					Code0=uH;
					if(s[2]==R5)						// half
					{
						Code1=uA;	Code2=uL;	Code3=uF;
					}
					else 	goto IGH;				// high
				}
				else if(s[2]==R5)
				{
					Code2=uL;	Code3=uE;			// tele
				}
				else 								// web
				{
					Code0=uW;	Code2=uB;
				}
				goto RET;
			}
			Code1=uH;								// thr thl chr chl
		}
		else if(s[0]==R8)
		{
			if(bn) 
			{
				Code0=uS;	Code1=uN;	goto PushA;	// sn
			}
			if(s[2]==R0)								// ready
			{
				PushAsc3(uR,uE,uA);	Code0=uD;	
				goto YRET;
			}
			else
			{
				PushAsc2(uE,uN);	goto OUGH;			// enough
			}
		}
		else if(s[0]==R7)      
		{
			if(s[2]==R0)
			{
				if(s[1]==R8)	
				{
					Code0=uS;	Code1=uM; 			// sm
					if(bn==0)
					{
						if(Num)	Code0=uM;			// mm
						else if((CurKeyL==0)&&((CurKeyT&3)==0))
					 		PushAsc(uI);				// ism
					} 
				}
				else		{ Code0=uT;	Code1=uZ; }	// tz
			}
			else if(s[1]==R8)	
			{ 
				Code0=uG;	Code1=uN; 				// gn
				if(s[2]==R9)	{ Code1=uH;	Code2=uT; }	// ght
			}
			else if(s[1]==R9)	
			{
			WH:
				PushAsc(uW);		Code0=uH;			// wh
				if(bn==0)							// while
				{
					Code1=uI;	
				LE:
					Code2=uL;	goto ERET;
				}
			}
			goto PushA;
		}
		else if((s[0]==R3)&&(s[1]==R6)&&(s[2]==R7))		// pect
		{
			Code0=uP;	goto ECTS;
		}
		else if((s[0]==R3)&&(R6<=s[1]))
		{
			if(s[1]==R7)	{ Code0=uS;	Code1=uW;goto PushA; }	// sw
			else if(s[2]==R0)	{ Code0=Code1=uD;	goto PushA; }	// dd
			else if(bn==0)									// cept
			{
			EPT:
				Code1=uE;	
			PT:
				Code2=uP;	Code3=uT;
				goto RET;
			}
			else 	Code1=uK;					 			// ckl
		}
		else if(s[0]==R1)
		{
			if((s[1]==R8)||(s[2]==R8))	
			{
				if(s[2]==R8)			Code0=uJ;	// ject
				else if(s[2]==R9)		Code0=uS;	// sect
				else if(s[2]==R0)		Code0=uR;	// rect
				else 
				{
									Code0=uL;	// lect
					if(b[0]==L6)
					{
						PushAsc(uE);	bn=0;		// elect
					}
					else if((b[0]==L7)&&(bn==1))
					{
						Code2=uL;	goto CT2;	// ctly
					}
				}
			ECTS:
				Code1=uE;	goto CT;
			}
			else if(s[1]==R9)
			{
				Code0=Code2=uE;	Code1=uV;
				if(s[2]==R0)
				{
					if((bn==0)||((bn==1)&&(b[0]==L6)))
					{
					 	Code3=uR;					// ever every
					 	if(bn)	b[0]=L7;
					}
					else
					{
						Code0=0;	Code1=Code2=uR;		// rr
						if(((b[0]==L6)&&(b[1]==L7)&&(b[2]==L0))||((b[0]==L7)&&(b[1]==L9)))
							Code0=uA;				// arrange arrive
					} 
				}
				else
				{
					Ret=1;
					if(bn==1)
					{
						if(b[0]==L6)					// event
						{
							PushAsc2(Code0,uV);	Code1=0;	goto ENTR;
						}
						else if(b[0]==L9)				// eleven
						{
							PushAsc2(uE,uL);
						}
						else if(b[0]==L8)				// seven
						{
							PushAsc(uS);
						}
						else 	goto LL;
					}
					else if((b[2]==L3)&&(bn==3))		// evening
						Ret=0;				
					else if(bn)						// ll
					{
						if((b[0]==L6)&&(b[1]==L7)&&(b[2]==L0))
							PushAsc3(uC,uH,uA);		// challenge
					LL:
						Code0=Code1=uL;	Code2=0;		Ret=0;	goto PushA;
					}
					Code3=uN;						// even
				}
				goto PushA;
			}
			else if(s[1]==R7)
			{
				if(bn)	
				{ 
					if(s[2]==R0)	Code0=uD;			// dw
					Code1=uW; 						// tw
				}
				else 
				{
					if(s[2]==R5)	Code0=uL;			// lt	
					else 		Code0=uN;			// nt
					Code1=uT;
				}
				goto PushA;
			}
		}
		else if(s[0]==R4)
		{
			Code0=0;
			if((s[1]==R6)&&(s[2]==R5))
			{
				if(bn==0)
				{
					Code0=uN;	goto INE;			// nine
				}
				Code0=Code1=uD;						// ddl
			}
			else if(s[2]==R0)
			{
				if(s[1]==R6)							// sph phra
				{
					Code1=uP;	Code2=uH;
					if(b[0]!=L0)	{ Code0=uS;	goto PushA; }
				}
				else 
				{
					PushAscL(uM);						// Mr. Mrs. Ms. 
					if(!bn||(b[0]!=L1))	PushAsc(uR);
					if(bn&&(b[0]<=L2))	PushAsc(uS);
					PushCode00(55);						
					goto SPR;
				}
			}
			else 
			{
				Code0=Code1=uZ;						// zz
				if(bn)	Code2=uL;					// zzl
				goto PushA;
			}
		}

		if(sn<=2)	;
		else if(s[2]==R0)		Code3=uR;		// r
		else if(s[2]==R5)		Code3=uL;		// l
		else if(s[2]==R4)		Code3=uH;		// h

		goto PushA;
	}

PushA:
	if(Code0)	PushAsc(Code0);
	if(Code1)	PushAsc(Code1);
	if(Code2)	PushAsc(Code2);
	if(Code3)	PushAsc(Code3);
	if(Sp)		PushAsc(uSp);
	if(Ka)		PushCode10(37);
	if(Ret||(bn==0))
	{
		if(Th)	PushAsc2(uT,uH);
		if((LastS==uD)&&(Code2==uH))	PushAsc2(uE,uR);	// daughter
		if(Ctrl)	CtrlSet=Ctrl=0;
		return;
	}

BOIN:
	if(sn)	LastS=LastCode;
	Code0=KeyCodeAsc[b[0]/8][b[0]%8];
	Code1=Code2=Code3=Sp=Ka=0;	Ret=1;
	
	if(bn==4)
	{
		if((b[0]==L7)||((b[2]==L4)&&(b[3]==L5)&&(b[0]!=L1)))
		{
			if(b[0]!=L7)
			{
				if((LastS==uR)||(LastS==uD))	Code0=uO;	// doll roll
				else 						Code0=uA;	// all
			}
			else 							Code0=uU;	// ull
			Code1=Code2=uL;		goto PushA;
		}
		if((b[0]==L1)&&(b[1]!=L3))
		{
			if((L7<=b[1])&&(L8<=b[2])&&(b[3]==L5))
			{
				Code1=uX;									// ex
				if(LastS==uB)			Code0=uO;				// box
				else if((LastS==uM)||(LastS==uF))	Code0=uI;	// mix fix
				else if((LastS==uN)||(LastS==uT))	Code2=uT;	// next text
				goto PushA;
			}
			if((L0<=b[3])&&(b[1]==L2)&&(L8<=b[2]))
			{
				if(b[3]==L5)
				{
					Code2=uL;
					if(b[2]==L9)
					{
						Code0=uI;	Code1=uA;					// ial
						if((LastS==uF)||(LastS==uH)||(LastS==uY))	// field shield yield
						{
							Code1=uE;	Code3=uD;
						}
						else if((LastS==uG)||(LastS==uL))			// giant liant
						{
							Code2=uN;	Code3=uT;
						}
					}
					else 
					{
						Code0=uA;								// ail
						if((LastS==uP)||(LastS==uC))	goto ERET;	// pale scale
						Code1=uI;
						if(LastS==uD)		goto YRET;				// daily
					}
					goto PushA;
				}
			}
			else 
			{
				if(b[3]==L0)			Code0=uO;		// ong
				else if(b[3]==L4)	
				{
					Code0=uU;						// ung
					if(sn==0)						// America
					{
						PushAscL(uA);		PushAsc3(uM,uE,uR);
						Code0=uI;	Code1=uC;	Code2=uA;
						goto PushA;
					}
				}
				else 
				{
					if((LastS==uL)||(LastS==uR))	Th=1;	// length strength
					else 
					{
						if((LastS==uH)||(LastS==uW))	;	// here there where were
						else if((LastS==uF)||(LastS==uM)
						||((sn==2)&&(LastS==uT)&&(s[0]==R1)&&(s[1]!=R8)))
							Code0=uO;					// fore more store  !picture
						else if((sn==0)&&(CurKeyR==0))		// able
						{
							Code0=uA;	Code1=uB;	goto LE;
						}
						else 	Code0=uU;				// ure 
					RE:
						Code2=uR;	goto ERET;
					}
				}
			NG:
				Code1=uN;	Code2=uG;	goto PushA;
			}
		}
		else if((b[3]==L5)&&(b[0]==L2))
		{
			if(b[1]==L3)
			{
				Code0=uO;	Code2=uS;					// os
				if(LastS==uC)								// cause
				{
					Code0=uA;	Code1=uU;	goto ERET;
				}
				else if((LastS==uB)||(LastS==uT))
					Code1=uS;							// boss toss
				else if((LastS==uN)||((LastS==uL)&&(s[0]==R3))||((LastS==uH)&&(s[0]!=R2))
					||(LastS==uP)||((LastS==uR)&&(sn==1)))
					goto ERET;				// nose close those whose chose pose rose
				else if((LastS==uL)||(LastS==uM)||(LastS==uR))
					;									// los mos pros
				else if(sn)
				{
					Code1=uE;							// oes
					if(LastS==uV)		Code1=uU;			// vous
				}
			}
			else if(b[2]==L9)								// ity
			{
				if(LastS==uB)		PushAsc2(uI,uL);			// bility
				Code1=uT;	goto YRET;
			}
			else if((LastS==uB)||(LastS==uG))				// buil guil
			{
				Code0=uU;	Code1=uI;	Code2=uL;
			}
			else										// ium
			{
				if(LastS==uS)		Code0=uE;				// seum
				Code1=uU;	Code2=uM;
			}
			goto RET;
		}
		else 
		{
			Code2=uN;
			if(b[3]==L5)
			{
				if(b[0]==L3)								// own
				{
					Code1=uW;	
					if(((s[0]==R2)||(s[0]==R7))&&(s[1]!=R4))
						Code1=uO;						// moon noon soon spoon
					goto RET;
				}		
				Code2=uL;								// oul
			}
			else if(b[0]==L2)
			{
				if(b[2]==L4)	{ Code1=uA;	 goto RET; }		// ian
				Code1=uT;
				if((LastS==uC)&&(sn==2))	Code1=uS;		// (occ)asion
				PushAsc2(uA,Code1);	goto ION;			// ation
			}
			else if(b[3]==L9)
			{
				if((LastS==uF)||(LastS==uV))
					PushAsc(uA);							// fault vault
				Code0=uU;	Code1=uL;	Code2=uT;
				goto PushA;								// ult
			}
			Code0=uO;	Code1=uU;
			if(b[0]<=L3)					goto PushA;		// oul oun
			Code3=uD;									// ould ound
			if((b[3]==L0)&&((LastS==uC)||(LastS==uM)))
				Code3=uT;								// count mount
			else if((sn==0)&&(b[3]==L5))
			{
				Code0=uA;
			AMPM:
				PushAsc(Code0);	PushCode00(55);			// a.m.
				PushAsc(uM);		PushCode00(55);
				return;
			}
			goto	PushA;
		}
	}
	if(3<=bn)
	{
		if((L6<=b[0])&&(b[1]<=L8)&&(b[2]==L5))
		{
			Code0=uA;		Code1=uR;					// ar
			if(b[0]==L7)		Code1=uL;					// al
			else if(b[1]==L8)								// arm
			{
				if((LastS==uC)||(LastS==uP))	Code1=uL;	// calm palm
				else if((LastS==uS)||(LastS==uG))
				{
					Code0=uY;	Code1=0;					// sym gym
				}
				Code2=uM;
			}
			goto PushA;
		}
		else if((L6<=b[0])&&(L8<=b[1])&&((b[2]==L0)||(b[2]==L5)))
		{
			Code0=uA;
			if(((b[0]==L8)&&(b[2]==L0))					
			||((b[0]==L7)&&(b[1]==L9)&&(b[2]==L5)
			&&((LastS==uW)||(LastS==uF)||(LastS==uC)||(LastS==uY))))
				Code0=uO;								// work fork cork york
			else if(((LastS==uS)||(LastS==uM))
			&&(b[0]==L7)&&(b[1]==L9)&&(b[2]==L0))
				Code0=uI;								// silk milk
			Code1=uR;
			if(b[2]==L0)
			{
				if(b[0]==L6)	Code1=uN;					// and ant
				else if(b[0]==L7)
				{
					Code1=uL;
					if(b[1]==L8)	
					{ 
						if(LastS==uF)
						{
							PushAsc2(uA,uM);				// family
							Code0=uI;	Code2=uY;
						}
						else 
						{
							Code1=uM;					// am
							if(LastS==uN)		Code2=uE;	// name
						}
						goto PushA;
					}
				}
			}
			Code2=uD;									// ard ord 
			if((b[0]==L8)||(b[1]==L8))						// art ort ant
			{
				Code2=uT;
				if(b[2]==L5)
				{
					if((LastS==uH)&&(sn==1))
					PushAsc(uE);							// heart
				}
				else if((b[0]==L8)&&(LastS==uC)&&(sn==1))	// court
				{
					PushAsc(uO);		Code0=uU;
				}
			}
			else if(b[0]==L7)								// ark alk
			{
				Code2=uK;
				if(sn==0)		Code2=uC;				// arc 
				if(LastS==uF)		Code0=uO;				// folk
			}
			else if((s[0]==R2)&&(s[1]==R4)) Code2=uP;		// sharp
			goto PushA;
		}
		else if(b[2]==L5)
		{
			if((b[1]==L6)||((b[0]==L1)&&(b[1]==L8)))
			{
				if((b[0]==L3)&&((LastS==uF)||(LastS==uW)||((LastS==uT)&&(sn==2)&&(s[1]==R2))))
				{
					Code1=uR;	Code2=uM; 				// form worm storm
				}
				else
				{
					Code1=uM;							// im om um em
					if(((b[0]==L3)&&(LastS==uB))
					||((sn==2)&&(((b[0]==L2)&&(s[0]==R3)&&(s[1]==R5))
							  ||((b[0]==L4)&&(s[0]==R1)&&(s[1]==R4)))))
						Code2=uB;						// bomb climb thumb
					if((b[0]==L4)&&(LastS==uJ))	Code2=uP;// jump
				}
			}
			else if((b[0]<=L3)&&(b[1]==L9))
			{
				Code2=uT;								// et it ot 
				if(b[0]==L3)
				{
					if(LastS==uF)
					{
						Code0=Code1=uO;					// foot 
					}
					else if((LastS==uN)&&(sn==1))	Code3=uE;// note knot
				}
				else if((b[0]==L1)&&(LastS==uD))			// debt
				{
					Code1=uB;
				}
			}
			else if((b[0]==L3)&&(b[1]==L4))	Code1=uW;	// ow aw
			else if((b[0]==L1)&&(b[1]==L3))		
			{
				Code0=uO;	
			NE:
				Code2=uN;
				if(LastS==uJ)		Code1=uI;				// join
				else 			Code3=uE;				// one
			}
			else if((b[0]<=L4)&&(L7<=b[1]))
			{
				Code1=uL;									// il ol el ul
				if(b[0]==L2)
				{
					if((LastS==uH)&&(s[0]==R3))	Code2=uD;	// child
					if(LastS==uM)					Code2=uE;	// mile smile
				}
				else if((b[0]==L3)&&(LastS==uH)&&(sn!=1))
					Code2=uE;								// whole 
				else if((b[0]==L1)&&(LastS==uF))
					Code2=uT;								// felt
			}
			else if((b[1]==L2)&&(sn==0)&&((CurKeyR&0x80)==0))	// !xie
			{
				Code0=uE;	Code1=uR;						// er
				if(CurKeyR||(CurKeyL&0x80))	Code2=uN;		// ern
			}
			else if(b[1]==L3)									// oi
			{
				Code0=uO;	Code2=uI;
				if((LastS==uJ)||(LastS==uT)||((LastS==uR)&&(s[1]==R2)))
				{
					Code2=uY;								// joy toy (de)stroy
					if((sn==2)&&(LastS==uT))	Code1=uR;		// story
				}
				else if(sn==0)
					Code3=uL;								// oil
			}
			else if((b[0]==L2)&&(b[1]==L4))
			{
				Code0=uU;	Code1=uI;
				if(((s[0]==R9)&&(s[1]==R0))||(LastS==uS)||(LastS==uC))
					Code2=uT;								// fruit suit (bis)cuit
				else if((LastS==uG)||(LastS==uJ)				// gui jui
					||((LastS==uR)&&(2<=sn)&&(s[0]!=R6)))	;	// brui crui !price
				else
				{
					Code0=0;		 goto ICE;					// ice	
				}
			}				
			else 
			{
				bn=2;	aswap=1;		goto BN2;
			}
			goto PushA;
		}
		else if((b[0]==L6)&&(b[1]==L7)&&(b[2]==L0))
		{
			Code0=uA;	Code1=uN;	Code2=uG;				// ang
			if((sn==0)||(LastS==uD)||(LastS==uT)||(LastS==uV)||(LastS==uY)
				||((s[0]==R8)&&(s[1]==R5))||(LastS==uC))
				goto NCE;						// ance dance stance vance yance glance cance
			else if((s[0]==R1)||(s[0]==R9))
			{
				if((s[1]==R3)||(s[1]==R4)||(s[0]==R9))
					Code2=uK;								// thank bank blank frank
				else if(s[1]==R0)		Code2=uS;				// trans
				else if(((LastS==uR)||(LastS==uL))&&(sn==3))
				{
					if(LastS==uL)	Code0=uE;					// (cha)llenge
					goto ERET;								// strange (a)rrange 
				}
			}
			else if(s[1]==R4)		goto ERET;					// change 
		}
		else if((b[0]==L1)&&((b[2]==L0)||(b[3]==L0)))
		{
			if((b[1]==L4)&&(LastS!=uB))						// beau
			{ 
				Code1=uP; 
				if((LastS==uP)||((sn==1)&&(LastS==uH))||(sn==0))
					Code0=uO;								// pop hop op
				else if(LastS==uD)	{ Code0=uE;	Th=1; }		// depth
				else if((LastS==uW)&&(sn==2))
					{ Code0=uI;	Code1=uD;	Th=1; }			// width
				else if(LastS==uS)	Code0=uU;				// sup
				else
				{
					Code0=uA;								// ap
					if((s[0]==R2)&&(s[1]<=R4)&&(sn==2))
						goto ERET;							// shape (e)scape 
					if((s[0]==R8)&&(s[1]==R0))	Code2=uH;		// graph
				}
			}
			else 
			{
				Code1=uA;									// ea
				if(bn==4)
				{
					if(b[2]==L8)								// een 
					{			// clean mean jean pean lean cean nean dean ean 
						Code2=uN;
						if((s[0]==R3)||(LastS==uM)||((s[0]==R7)&&(s[1]==R8))
						||((s[0]==R6)&&(s[1]==R7))||(s[0]==R5)||(LastS==uN)
						||(LastS==uD)||!CurKeyR)	;
						else if(LastS==uC)	{ Code1=0;	goto ERET; }	// scene
						else Code1=uE;
					}
					else if(LastS==uD)	{ Code1=uE;	Code2=uP; }	// deep
					else 									// eam
					{
						Code2=uM;			
						if((sn==1)&&(s[0]==R2))	Code1=uE;	// seem
					}
				}
				else if(b[1]==L2)
				{
					if((sn==0)||(LastS==uD)||(LastS==uG)||(LastS==uU))
						goto NCE;							// ence dence gence quence
					Code1=uE;								// ee
				}
				else if(b[1]==L8)
				{
					if(((sn==2)&&(LastS==uH)&&(s[0]==R3))||(LastS==uU))
						Code1=uE;							// cheer queer
					Code2=uR;								// ear
					if(LastS==uS)								// search
					{
					SEARCH:
						PushAsc(uE);
						Code0=uA;	Code1=uR;
						if(LastS==uS)		goto CH;
						goto ONLY;							// early
					}
					else if((LastS==uM)||(LastS==uV)||(LastS==uC))	// mere (se)vere cere
					{
						Code1=0;		goto ERET;
					}
					else if((LastS==uL)&&(sn==1))	Code3=uN;	// learn
				}
				else if(b[1]==L9)
				{
					if((sn==1)&&(LastS==uT))					// teeth 
					{
						Code1=uE;	goto TH;
					}
					Code2=uD;								// ead
					if(sn==0)								// east
					{
						Code2=uS;	Code3=uT;
					}
					else if(LastS==uW)
					{
						if(s[0]==R3)	Code2=uT;				// sweat 
						else 		Code2=uK;				// weak
					}
					else if((s[1]==R7)&&(s[0]!=R3))			// peace please
					{
						Code2=uC;	
						if(s[2]==R5)	Code2=uS;
						goto ERET;
					}
					else if((s[0]==R3)&&(s[1]==R0))			// create
					{
						Code2=uT;	goto ERET;
					}
					else if((s[0]==R3)&&(s[1]==R4))			// cheek
					{
						Code1=uE;	Code2=uK;
					}
					else if(((sn==1)&&(s[0]!=R4)&&(s[0]!=R6)&&(s[0]<R0))	// !head dead read lead
					||((sn==2)&&((s[0]==R2)&&(s[1]==R6))||((s[0]==R3)&&(s[1]==R7))||((s[0]==R8)&&(s[1]==R0))))
						Code1=uE;				// need seed feed ceed speed cceed greed
				}
				else if(b[1]==L7)
				{
					Code2=uL;									// eal
					if((LastS==uF)||((LastS==uH)&&(2<=sn))||(LastS==uN))	Code1=uE;
					else if(LastS==uH)	Th=1;					// health
				}												// feel wheel kneel
				else if(b[1]==L3)
				{
					Code2=uK;									
					if(((s[2]==R0)&&(s[1]==R3)&&(s[0]==R1))||((s[0]==R2)&&(s[1]==R6)))	;
																// break speak 
					else if(LastS==uD)	{ Code2=0;	Th=1; }		// death
					else if((LastS==uK)||((s[0]==R2)&&(s[1]==R5)))
					{
						Code1=uE;	Code2=uP;					// keep sleep
					}
					else if((s[0]==R7)&&(s[1]==R5))	Code1=uE;	// week
					else if(((s[0]==R2)&&(s[1]==R4))||((s[1]==R2)&&(s[2]==R0))
					||((sn==1)&&(s[0]==R9))||((s[0]==R7)&&(s[1]==R0))
					||((s[0]==R3)&&(s[1]==R7)))
					{
						Code1=uE;	Code2=uT;			// sheet street feet meet sweet
					}
					else if((s[0]==R3)&&(s[1]==R4))
						Code2=uP;						// cheap
					else Code2=uT;						// eat
				}
				else Code2=uU;
			}
		}
		else if(b[2]==L3)
		{
			Code0=uI;	goto NG;							// ing
		}
		else if(b[2]==L4)
		{
			if(b[1]==L2)
			{
				Code0=uU;	Code1=uT;					// ut
			}
			else 
			{
				if(b[0]==L2)
				{
				IGHT:
					Code1=uG;	Code2=uH;	Code3=uT;
					if((LastS==uC)||(LastS==uD)||((s[1]==R2)&&(sn==2)))
					{ 
						PushAsc(uA);	Code0=uU; 		// caught daughter taught 
					}
					else if((sn==0)||((sn==2)&&(LastS==uH)))
					{
						PushAsc(uO);	Code0=uU;		// ought thought
					}
					else if(LastS==uY)				// yacht
					{
						Code0=uA;	Code1=uC;
					}
					else 
					{
						if((LastS==uH)||(LastS==uW))	PushAsc(uE);	// height weight
						else if((sn==3)&&(s[1]==R2))	PushAsc(uA);	// straight
						Code0=uI;
					}
				}
				else 
				{
				OUTR:
					Code0=uO;	Code1=uU;	Code2=uT;	// out
					if(LastS==uL)		Code2=uD;			// loud cloud
					else if((sn==1)&&(LastS==uD))
					{
						Code2=uB;	Code3=uT;			// doubt
					}
					else if((LastS==uM)||(((LastS==uN)||(LastS==uT))&&(sn==1))
						||(LastS==uS)||(LastS==uW)||(LastS==uY))
					{									// mouth north south worth youth
						Code3=uH;
						if((LastS==uN)||(LastS==uW))	Code1=uR;
						else if((sn==3)||(LastS==uT))	Code1=uO;	// smooth tooth
					}
				}
				goto RET;
			}
		}
		else if((b[0]==L2)&&(b[1]!=L3)&&(b[2]==L0))
		{
			Code0=uA;	Code1=uI;
			if(b[1]==L4)	Code1=uW;			// aw
			else if(b[1]==L6)
			{
				if((sn==0)||((s[0]==R3)&&(s[1]==R5)))	
					Code2=uM;				// aim claim
				else
				{
					Code2=uN;				// ain
					if(LastS==uF)	Code3=uT;	// faint
				}
			}
			else if(b[1]==L8)
			{
				Code2=uR;
				if((sn==0)||((sn==1)&&((LastS==uH))||(LastS==uF))
				||((sn==2)&&(((LastS==uP)&&(s[0]==R6))||(LastS==uT)||((LastS==uH)&&(s[0]==R3)))))
					;						// air fair hair pair chair stair
				else if((sn==2)&&(s[0]==R1)&&(s[1]==R4))
					Code0=uE;							// their
				else 
				{
					Code1=0;		goto ERET;				// are
				}
			}
			else if(LastS==uW)	Code2=uT;				// wait
			else if((sn==0)||(LastS==uS)||(LastS==uP)||((LastS==uR)&&(s[0]==R9)))
				Code2=uD;								// aid said paid (a)fraid
			else
			{
				Code1=uT;	goto ERET;					// ate 
			}
		}
		else if((b[0]==L3)&&(b[2]==L0))
		{
			switch(b[1])
			{
			case L4:		Code1=uU;	break;				// our
			case L6:		Code1=uA;	break;				// oar
			case L7:		Code1=uR;	break;				// ord
			case L9:		Code1=uL;						// old
				if((LastS==uW)||(LastS==uM))	Code0=uI;	// wild mild
			}
			if(b[1]<=L6)	Code2=uR;
			else 		Code2=uD;
			if((b[1]==L6)&&(LastS==uB))	Code3=uD;		// board
		}
		else if((b[0]==L4)&&(b[2]==L0))
		{
			Code1=uA;									// ua
			if(b[1]==L6)
			{
				if(LastS==uG)
				{
					Code2=uR;	Code3=uD;				// guard
				}
				else Code2=uL;							// ual
			}
		}
		else if((L2<=b[0])&&(b[2]==L6))
		{
			if(b[1]==L3)
			{
			ION:
				Code1=uO;	Code2=uN;	goto RET;		// ion
			}
			else if(b[0]==L3)
			{
				Code1=uO;								// oo
				if(((sn==3)&&(LastS==uH)&&(s[0]==R2))||(LastS==uF))
					Code2=uL;							// school fool  
				if(((sn==1)&&(LastS==uD))||((sn==2)&&(LastS==uL)&&(s[0]==R9)))
					Code2=uR;							// door floor
			}
			else 
			{
				Code0=uU;	Code1=uS;					// us
			}
		}
		else if(b[2]<=L9)
		{
			if(b[2]==L8)
			{
				if(b[1]==L2)
				{
					Code0=uI;	Code1=uP;				// ip
					if((sn==2)&&(LastS==uT))	Code0=uE;	// step
					else if(LastS==uC)		Code0=uU;	// cup
					else if(LastS==uP)		goto ERET;	// pipe
					else if(LastS==uB)		Code1=uG;	// big
					else if(sn==0)			goto ISH;	// ish
					goto PushA;
				}
				else if(b[0]==L6)
				{
				ENTR:
					Code0=uE;
					if((LastS==uH)&&(s[0]==R1))	goto SE;	// these
				NTR:
					Code2=uN;	Code3=uT;				// ent
					if((sn==0)&&(CurKeyR==0)&&(CurKeyT==0))
					{
						if(Caps)	CapsToggle();				// int
						Code0=uI;
					}
					else if((((s[1]==R7)||(s[1]==R6))&&(s[2]==R0))||(LastS==uH))
						Code0=uI;						// print sprint hint 
					else if(LastS==uF)	Code0=uO;		// font
					goto RET;
				}
			}
			else if((b[1]==L7)||(b[0]==L7))	Code0=uI;
			else if(b[0]==L6)								// ite
			{
				Code0=uI;	Code1=uT;	goto ERET;
			}
			else if((b[2]==L7)&&(b[0]==L3))
			{
			ESS:
				Code0=uE;								// ess
				if(sn==2)
				{
					if(s[0]==R3)
					{
						if(s[1]==R5)		Code0=uA;		// class
						else if(s[1]==R0)	Code0=uO;		// cross
					}
					else if((s[1]==R7)||(s[0]==R8))
						Code0=uA;						// pass glass grass
					else if((LastS==uK)||(LastS==uM))
						Code0=uI;						// kiss miss
					else if(LastS==uB)					// business
					{
						PushAsc3(uU,uS,uI);	PushAsc(uN);
					}
				}
				Code1=Code2=uS;		goto RET;
			}
			if(b[0]==L7)
			{
				Code0=uO;	Code1=uU;	Code2=uS;
				if((LastS==uL)||(LastS==uM))	;			// lous mous
				else if((sn==1)&&(LastS==uH))	goto ERET;	// house
				else if(LastS==uN)	Code0=uI;			// nius
				else if(sn||CurKeyR)	PushAsc(uI);			// ious
				goto PushA; 
			}
			else if(b[2]==L8)
			{
				if(b[0]<=L2)	Code1=Code2=uL;				// ell ill
				else 		Code1=uN;					// en 
			}
			else if(b[0]==L2)
			{
				Code1=uN;	Code2=uK;	goto PushA;		// ink
			}
			else
			{
				if((b[0]==L1)&&(b[1]==L8))					// ast
				{
					Code0=uA;
					if(LastS==uW)		Code1=uI;			// waist
					if((s[1]==R3)&&(s[2]==R0))	PushAsc(uE);	// breast
				}
			ST:
				Code2=uS;	Code3=uT;					// est ist ost ust
				goto RET;
			}
		}
		else if(b[2]==L0)	
		{
			Code1=uA;									// ia
			if(sn==0)
			{
				Code0=uB;	goto YE;						// bye
			}
			goto PushA;
		}
	}
					
	if(bn==1)	goto PushA;
BN2:	
	if(bn==2)
	{
		if(b[0]==L1)
		{
			if((b[1]==L7)&&(sn==0)&&(aswap==0))
			{
			YE:
				Code1=uY;	Code2=uE;	goto PushA;		// eye
			}
			else if(b[1]==L3)								// ack
			{
				if((LastS==uP)&&(s[1]==R7))				// people
				{
					PushAsc2(uE,uO);	Code0=uP;	goto LE;
				}
				if(LastS==uD)		
				{
					Code0=uO;	Code1=uG;	goto RET;		// dog
				}
				else if((LastS==uG)||((LastS==uH)&&(s[0]==R1)));	// geo theo 
				else 	
				{
					Code0=uA;	Code1=uC;				
					if(((sn==1)&&(LastS==uT))||((sn==2)&&(LastS==uM))||(LastS==uW))
						Code1=uX;						// tax max wax
					else if((LastS==uF)||(LastS==uC)||((s[1]==R7)&&(s[2]==R5))||(LastS==uP))
					{									// face case place space
						Code2=uE;
						if(LastS==uC)	Code1=uS;
					}
					else if(sn)
					{
						Code2=uK;						// ac ack
						if(((sn==2)&&(s[0]==R3)&&(s[1]==R4))||((sn==1)&&(LastS==uN)))
							Code0=uE;					// check neck
						else if(((sn==2)&&(s[0]==R2)&&(s[1]==R4))||((s[0]==R6)&&(LastS==uN))
						||((LastS==uR)&&(sn==1))||((LastS==uL)&&(sn!=3)))
							Code0=uO;					// shock knock rock lock clock !black
					}
					goto PushA;
				}
			}
			else if((b[1]==L2)&&(LastS==uU))	Code2=uT;	// quiet
		}
		if((b[1]==L0)&&(b[0]==L8)&&(sn==0))
		{
			Code0=uQ;	goto PushA;					// q
		}
		if((L6<=b[0])&&(b[1]==L9))
		{
			Code1=uN;	Code2=uD;	
			if(b[0]==L6)
			{
				if((s[0]==R9)&&(s[1]==R0))	PushAsc(uI);	// friend
				Code0=uE;
			}
			else if(b[0]==L7)	
			{
				Code0=uI;
				if((LastS==uL)&&(s[1]==R3))	;		// blind kind mind wind hind find grind
				else if((LastS==uB)||(LastS==uK)||(LastS==uM)||(LastS==uW)
					||((sn==1)&&(LastS==uH))||(LastS==uF)||((LastS==uR)&&(s[0]==R8)))	;
				else 
				{
				VE:
					Code1=uV;	Code2=uE;			// ive
					if((sn==0)&&(CurKeyR==0))
						Code0=uE;					// eve
				}
			}
			else if(b[0]==L8)		Code0=uO;			// ond
			goto RET;								// end ind
		}
		if((L6<=b[0])&&(b[1]<=L8))
		{
			if(b[1]==L7)
			{
				Code0=uE;
				if((s[0]==R9)&&(R0<=s[1]))	Code2=uH;	// fresh flesh
			}
			else if(b[0]==L7)
			{
				if((LastS==uF)||((s[0]==R8)&&(s[1]==R5)))
				{
				ISH:
					Code2=uH;						// fish (En)glish
				}
				Code0=uI;
			}
			else
			{
				Code0=uA;	
			}
			Code1=uS;	goto RET;					// es is as
		}
		if(b[0]==L9)
		{
			if(b[1]==L0)	Code1=uD;
			else 		Code1=uT;
			Code0=uA;	goto PushA;					// ad at
		}
		if((b[0]==L1)&&(b[1]==L4))
		{
			if(sn==0)
			{
				if(!aswap)	Code1=uU;				// eu
				else 		goto LE;					// ele
			}
			else if(!aswap)
			{
				if(LastS==uV)		PushAsc(uI);			// view
				Code1=uW;							// ew
				if(LastS==uU)	{ Code1=uU;	goto ERET; }	// queue
			}
			if(!aswap)	goto PushA;
		}
		if((b[0]==L2)&&(b[1]==L4)&&(aswap==0))
		{
			Code1=uC;								// ic
			if((sn>=3)&&(LastS==uH))	Code2=uH;		// which
			goto PushA;
		}
		if((b[0]==L2)&&(b[1]==L0))						// age
		{
			Code0=uA;	Code1=uI;
			if(LastS==uR)
			{
				Code1=uI;							// rai prai brai
				if((s[0]==R1)&&(sn==2))	Code2=uT;	// trait
				goto RET;
			}
			if(LastS==uF)		{ Th=1;	goto RET; }		// faith
			Code1=uG;	goto ERET;
		}
		
		if((b[1]==L0)&&(b[0]!=L1)&&(b[0]!=L3))
		{
			if((LastS==uB)&&(b[0]==L4))
			{
				Code0=uA;	Code1=uG;	goto RET;	// bag
			}
			aswap=1;									// !ea !oa au ay
		}
		if(aswap)
		{
			i=b[0];	b[0]=b[1];	b[1]=i;
		}
		
	BOIN2:
		Code0=KeyCodeAsc[b[0]/8][b[0]%8];
		Code1=KeyCodeAsc[b[1]/8][b[1]%8];
		
		if(b[1]==L5)
		{
			Code1=uR;								// er
		}
		else if(b[1]==L6)
		{
			Code2=uN;	Code1=0;
			if((LastS==uJ)&&(b[0]==L3))	Code1=uH;	// john
		}
		else if((b[1]==L8)||((L3<=b[0])&&(b[1]==L7)&&(b[0]!=L0)))
		{
			if(b[0]==L1)	Code1=uN;					// en
			else 
			{
				Code1=uR;							// ir or ur
				if(b[0]==L2)
				{
					if(LastS==uF)		Code2=uM;		// firm
					else if(LastS==uB)	Th=1;		// birth
					else if(((LastS==uH)&&(s[0]==R2))||(LastS==uK))
						Code2=uT;					// shirt skirt
				}
			}
		}
		else if(b[1]==L9)
		{
			Code1=uD;
			if(b[0]==L3)
			{
				if((sn==0)||(LastS==uN)||(LastS==uP)||((LastS==uH)&&(sn==2))||(LastS==uR))	;
					 								// od nod pod thod rod 
				else if((LastS==uC)||(LastS==uM))
					goto ERET;						// code mode
				else if(LastS==uB)	Code2=uY;		// body
				else
				{
					Code1=uO;	Code2=uD;			// ood
				}
			}
			else if(b[0]==L2)
			{
				if((LastS==uS)||(LastS==uW)||(LastS==uC)||(LastS==uV)||(LastS==uT))
					Code2=uE;						// side wide cide vide tide
			}
		}
		else if((b[0]==L3)&&(b[1]==L0))
		{
			if(((LastS==uR)&&(s[0]!=R6)&&(s[0]!=R3))||(LastS==uM))
			{
				Code2=uD;							// road broad
				if(s[1]==R4)	Code2=uT;				// throat
				else if((s[0]==R8)||(LastS==uM))
					Code2=uN;						// groan moan
			}
			else if((sn==4)&&(LastS==uR))	goto CH;		// approach
		}
	}
	goto PushA;	
}

void PushCode(byte Code, byte shift, byte kana)
{
	word *Last0;

	Last0=Last;
	Last++;
	if(&ModeCodeBuf[15]<Last)	Last=&ModeCodeBuf[0];
	if(Last==Top)	{ Last=Last0;	return; }	// ModeCodeBuf=full

	*Last0=(word)Code&0x00FF;
	if(kana==1)		*Last0|=0x1000;		// KanaOn
	else if(!kana)	*Last0|=0x2000;		// KanaOff

	if(shift==1)		*Last0|=0x4000;		// ShiftOn
	else if(!shift)	*Last0|=0x8000;		// ShiftOff

	if(Ctrl)		*Last0|=0x0100;
	if(Shift)	*Last0|=0x0200;
	if(Alt)		*Last0|=0x0400;
	if(Win)		*Last0|=0x0800;
}

void SetKey(byte Ep)
{
	byte Code,Mode;

	if((idle_rate[0]!=0)&&IdleTimer0)	return;
	if(LEDWait)		return;
	
	if(Ep)	// Interrupt In
	{
		if(Ep1Busy)	return;
		if(Top==Last)			// Mf[^Ȃ
		{
			if(idle_rate[0]!=0)	{ Code=CODE;	Mode=MODE;	goto SET; }
			return;
		}
	}
	else 	// GetReport EP0
	{
		if(Top==Last)		{ Code=CODE;	Mode=MODE;	goto SET; }
	}
	
	Mode=(byte)((*Top&0x0F00)>>8);
	Code=(byte)(*Top&0x00FF);

	if((Code==0)&&(KanaToggle==0))
	{
		Top++;
		if(&ModeCodeBuf[15]<Top)	Top=&ModeCodeBuf[0];
		
		if((Code==CODE)&&(Mode==MODE)&&Ep)	return;
		goto SET;
	}

	if(KanaToggle)		// ȃ[hύX̃L[Itf[^̑M
	{
		Code=0;	KanaToggle++;
		if(KanaToggle==2)			Mode=1;					// Mode=0ł̓JiONOFFłȂ
		else if(KanaToggle==3)	{ Mode=3;	Code=136; }	// Ctrl+Shift+
		else 					{ KanaToggle=0;	Mode=0; }
		goto SET;
	}
	if(((*Top&0x1000)&& !Kana)||((*Top&0x2000)&& Kana))	// KanaOnOff
	{
		if(Kana)	Kana=0;
		else	Kana=1;
		KanaToggle=1;
		Mode=1;	Code=uCaps;		goto SET;		// Ctrl+uCaps
	}
	
	if((*Top&0x4000)&& !(Mode&2))					// ShiftOn
		Mode|=2;
	else if((*Top&0x8000)&&(Mode&2))				// ShiftOff
		Mode&=0xFD;
	else if(ShiftSet&& !(Mode&2))					// ShiftOn
		Mode|=2;
	else if(!(*Top&0xC000)&&(Mode&2)&& !FirstCode)	// ShiftOff
	{
		Mode&=0xFD;
		ShiftSet=Shift=0;
	}

	if(Code&&(Code!=uCaps)&&(Code!=uScrollLock))
	{
		ShiftSet=CtrlSet=AltSet=0;
		FirstCode=0;		// VtgL[ȊÕL[ꂽ
		if(Code==CODE)	// ꕶ̘ÁL[Abv
		{
			Code=Mode=0;		goto SET;
		}
	}

	Top++;
	if(&ModeCodeBuf[15]<Top)	Top=&ModeCodeBuf[0];

SET:
	if(Ep)	// In Interrupt
	{
		if(active_protocol)	// Report Protocol
		{
			hid_report_in[0]=1;       	// ReportID
			hid_report_in[1]=Mode;
			hid_report_in[2]=0;		// Reserved
			hid_report_in[3]=Code;
		}
		else 				// Boot Protocol
		{
			hid_report_in[0]=Mode;
			hid_report_in[1]=0;		// Reserved
			hid_report_in[2]=Code;   
			hid_report_in[3]=0;
		}
		hid_report_in[4]=0;
		hid_report_in[5]=0;
		hid_report_in[6]=0;
		hid_report_in[7]=0;
		HID_BD_IN.Cnt=8;
		mUSBBufferReady(HID_BD_IN);
	}
	else 	// GetReport EP0 
	{
		if(active_protocol)	// Report Protocol
		{
			hid_report_in_0[0]=1;    	// ReportID
			hid_report_in_0[1]=Mode;
			hid_report_in_0[2]=0;		// Reserved
			hid_report_in_0[3]=Code;
		}
		else 				// Boot Protocol
		{
			hid_report_in_0[0]=Mode;
			hid_report_in_0[1]=0;		// Reserved
			hid_report_in_0[2]=Code;
			hid_report_in_0[3]=0;
		}
		hid_report_in_0[4]=0;
		hid_report_in_0[5]=0;
		hid_report_in_0[6]=0;
		hid_report_in_0[7]=0;
	}
		
	CODE=Code;	MODE=Mode;	

	IdleTimer0=idle_rate[0];
}

void SetMouse(byte Ep)
{
	if((idle_rate[1]!=0)&&IdleTimer1)	return;
	if(LEDWait)		return;
	if(!active_protocol)	return;
	
	if(Ep)	// Interrupt In
	{
		if(Ep1Busy)	return;
	}

	if((Button!=BUTTON)||MouseX||MouseY||Wheel||(Ep==0)||(idle_rate[1]!=0))
	{
		if(Ep)	// Interrupt In
		{
			hid_report_in[0]=2;       	// ReportID
			hid_report_in[1]=Button;
			hid_report_in[2]=MouseX;	
			hid_report_in[3]=MouseY;
			hid_report_in[4]=Wheel;
			HID_BD_IN.Cnt=5;
	    		mUSBBufferReady(HID_BD_IN);
	    	}
	    	else 	// GetReport EP0
		{
			hid_report_in_0[0]=2;		// ReportID
			hid_report_in_0[1]=Button;
			hid_report_in_0[2]=MouseX;	
			hid_report_in_0[3]=MouseY;
			hid_report_in_0[4]=Wheel;
	    	}
	    		
		BUTTON=Button;	
		MouseX=MouseY=Wheel=0;
		IdleTimer1=idle_rate[1];
	}
}

void MouseIn(void)
{
	if(Button||MouseX||MouseY||Wheel)	;
	else MouseTouch=!PORTAbits.RA4;
	
	if((KeyMouseTimer==0)&&KeyTouch&&!Num)
	{
		if(CurKeyL&0x01)		MouseX++;
		if(CurKeyL&0x04)		MouseX--;
		if(CurKeyL&0x02)		MouseY--;
		if(CurKeyL&0x20)		MouseY++;
		if(!MouseX&&!MouseY)	KEYMOUSE_TIME=14;
		KeyMouseTimer=KEYMOUSE_TIME;
		if(2<KEYMOUSE_TIME)	KEYMOUSE_TIME--;		// 
	}
	if(KeyWheelTimer==0)
	{
		if(CurKeyL&0x02)	Wheel++;
		if(CurKeyL&0x20)	Wheel--;
		if(Wheel)	KeyWheelTimer=KEYWHEEL_TIME1;
	}

 	if(!MouseTouch&&!KeyTouch)	KeyMouseTimer=KeyWheelTimer=-1;
	
	if(MouseTouch||KeyTouch)	PORTAbits.RA5=1;
	else 					PORTAbits.RA5=0;
}

void CountDown(void)		// USBSOFpPbgM(1ms)ɂČĂяo
{
	if(0<BreakTimer)		BreakTimer--;
	if(0<WaitTimer)		WaitTimer--;
	if(0<NumTimer)		NumTimer--;
	if(NumTimer==0)
	{
		if(KeyOn==2)	Num2=1;
		else		Num2=0;
		NumTimer=-1;
	}
	if(0<IdleTimer0)	IdleTimer0--;
	if(0<IdleTimer1)	IdleTimer1--;
	if(0<KeyMouseTimer)	KeyMouseTimer--;
	if(0<KeyWheelTimer)	KeyWheelTimer--;
}

void CapsToggle(void)
{
	PushCode10(uCaps);	// Shift+CapsLock
	SendWait();
	LEDWait=1;
	Wait(10);	
	LEDWait=0;
	ShiftSet=0;
	PushCode0();
}

void NumLockToggle(void)
{
	PushCode00(uNumLock);
	SendWait();
	LEDWait=1;
	Wait(10);	
	LEDWait=0;
	PushCode0();
}

void ScrollLockToggle(void)
{
	PushCode22(uScrollLock);
	SendWait();
	LEDWait=1;
	Wait(10);	
	LEDWait=0;
	PushCode0();
}

void Wait(int ms)	
{
	WaitTimer=ms;
	while(0<WaitTimer)
	{
		USBTasks();
		SetKey(1);
		SetMouse(1);
		MouseIn();
	}
}

void SendWait(void)		// DataMăobt@ɂȂ܂ő҂
{
	while(Top!=Last)
	{
		USBTasks();
		SetKey(1);
		SetMouse(1);
		MouseIn();
	}
}

void KanaModeOff(void)
{
	if(KanaMode)
	{
		KanaMode=0;	PushAsc(uCaps);
		Shift=ShiftSet=0;
	}
}